var c_w = getClientWH().w - 40;
var term = new Terminal({
  windowsMode: true,
  rows: 25,
  cols: parseInt(c_w/9)
});

function terminalSocket(id, that) {
  let host = window.location.host;
  var s = window.location.pathname;
  var i = s.lastIndexOf("/");
  var str = s.substr(0, s.lastIndexOf("/", i - 1));
  if (window.location.protocol == "https:") {
    socket = new WebSocket('wss://' + host + str + '/api/endpoints/1/websocket/exec/' + id.Id + '/start');
  }else {
    socket = new WebSocket('ws://' + host + str + '/api/endpoints/1/websocket/exec/' + id.Id + '/start');
  }

  const attachAddon = new AttachAddon.AttachAddon(socket);
  term.open(that_linkConsoleDesk.find('#terminal')[0]);
  const fitAddon = new FitAddon.FitAddon();
  term.loadAddon(fitAddon);
  socket.onopen = function(connection) {
    term.loadAddon(attachAddon);
  };

  socket.onmessage = function(message) {
    term.write(message);
  };
}
