function updatePassword() {
  let password = $('#jv-password').val();
  let newPassword = $('#jv-newPassword').val();
  let confirmPassword = $('#jv-confirmPassword').val();

  if (newPassword.length < 8) {
    $('#jv-docker_error').show();
    return;
  }else {
    $('#jv-docker_error').hide();
  }

  if (confirmPassword != newPassword) {
    errorMessageBox('两次密码不一样！');
    return;
  }

  let data = {
    NewPassword: newPassword,
    Password: password
  }

  let obj = {
    url: '../api/users/' + globalData.tty + '/passwd',
    type: 'put',
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      errorMessageBox('密码修改成功！');
    },
    complete: function(xhr, textStatus) {
      console.log(xhr);
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });

}

$('#jv-newPassword').bind('input porpertychange', function(){
	if($(this).val().length < 8){
		$('#jv-docker_error').show();
	}else{
		$('#jv-docker_error').hide();
	}
})

SPA_RESOLVE_INIT = function(transition) {
  // document.getElementById("content").innerHTML = '<p style="color:#099fde;">当前异步渲染首页'+ JSON.stringify(transition) +'</p>'

}

SPA_RESOLVE_HTML = function(transition) {

}


$(document).ready(function() {

  let lang = localStorage.getItem('lang');
  changeLanguage(lang);

})
