var initData = {
  list: [], //列表数据
  count: 0, //列表总数
  curr: 1, //当前页
  limit: localStorage.getItem('limit') || 10, //每页数量
  checkCount: 0, //已选列表数量
  deleteName: [], //保存删除列表名称
  containsId: '',
  is_import: false,
  is_openimage: false,
  delAssVol: 0,
  pullingList: [],
  createing_container : []
}
var first_ = 1;
var createing_jobid = [];

var creatingTime = null;
var unas_json = {};
var fileListType = [];
var dir_file = '';
// 日志初始化数据
var logPsotData = {
  since: 0,
  stderr: 1,
  stdout: 1,
  tail: 100,
  timestamps: 0
}

function getData() {
  initData.list = [];
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/json?all=1',
    type: "get",
  }
  postData(obj, {
    success: function(result) {
      if (result) {
        for (var i = 0; i < result.length; i++) {
          var tmp = result[i];
          if (tmp.State == 'running' || tmp.State == 'restarting') {
            result[i]['runstate'] = 1;
          }else {
            result[i]['runstate'] = 0;
          }
          var containername = tmp.Names ? tmp.Names.toString() : "";
          if (containername[0] == '/') {
            containername = containername.substr(1);
          }
          result[i]['containername'] = containername;
        }
        initData.list = result;
        initData.count = result.length;
        refreshInfo(containerSort('descending', 'containername', result), initData.count, initData.curr);
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  }, 1);

}

//数据更新
function refreshInfo(data, count, curr) {
  // console.log(data);

  var sortModle = localStorage.getItem('sortModle') || 'containername';
  var sortType = localStorage.getItem('sortType') || 'descending';
  data = containerSort(sortType, sortModle, data);

  layui.use('laypage', function() {
    var laypage = layui.laypage;
    laypage.render({
      elem: 'jv-paging',
      count: count, //数据总数，从服务端得到,
      limit: initData.limit,
      curr: curr,
      prev: ' ', //若不显示，设置false即可
      next: ' ', //若不显示，设置false即可
      jump: function(obj, first) {
        //obj包含了当前分页的所有参数，比如：
        // obj.limit 得到每页显示的条数
        initData.curr = obj.curr; //得到当前页，以便向服务端请求对应页的数据。
        $('#jv-gopage').text(obj.curr);
        $('#jv-pageitemV').text(initData.limit);
        let t = arrTrans(initData.limit, data);
        $('#jv-d-tbodybox').empty();
        $('#jv-checkboxAll').prop("checked", false);
        if (data.length) {
          var len = t[initData.curr - 1].length;
          for (var i = 0; i < len; i++) {
            let info = t[initData.curr - 1][i];
            var networkDom = wfTemplateAppend('#jv-d-tbodybox', 'jvt-d-tr', 'jvt-d-tr' + i);
            networkDom.find('.jvc-logDetails').attr('onclick', 'logDetails("' + info.Id + '")');
            networkDom.find('.jvc-checkContainer').attr('onclick', 'checkContainer("' + info.Id + '")');
            networkDom.find('.jvc-statisticsModule').attr('onclick', 'statisticsInfo("' + info.Id + '")');
            networkDom.find('.jvc-consoleDesk').attr('onclick', 'implementConsoleDesk()').data('dataInfo', info);
            networkDom.find('.jvc-startBtnStop').attr('onclick', 'dockerContainerControl("' + info.Id + '")');
            networkDom.find('.jvc-startBtnPlay').attr('onclick', 'dockerContainerControl("' + info.Id + '")');
            networkDom.find('.jvc-startBtnDelete').attr('onclick', 'dockerContainerControl("' + info.Id + '")');
            networkDom.find('.jvc-startBtnEdit').data('dataInfo', JSON.stringify(info));
            networkDom.find('.jvc-actionsExport').data('dataInfo', JSON.stringify(info));
            networkDom.data('dataInfo', info);
            seteChart(networkDom.find('.jvc-cupUsageEC')[0], 0, '#08cea1');
            networkDom.find('.jvc-startBtnMore').on('click', function(e) {
              e.stopPropagation();
              var x = e.clientX;
              var y = e.clientY;
              var vh = $(document).height();
              var wh = parseInt((y/vh)*100);
              if (wh > 70) {
                $(this).find('.moreOPbtnCn').addClass('moreOPbtnCnmax');
                $(this).find('.jvc-moreOPbox').css({
                  top: '-138px'
                })
              }else {
                $(this).find('.moreOPbtnCn').removeClass('moreOPbtnCnmax');
                $(this).find('.jvc-moreOPbox').css({
                  top: '25px'
                })
              }
              $(this).closest('div.dr-item').siblings().find('.jvc-moreOPbox').slideUp();
              $(this).find('.jvc-moreOPbox').slideToggle();
              $('.jvc-selectexportType').hide();
            })

            networkDom.find('.jvc-checkbox').data('dataInfo', info);
            let containerNamesStr = info.Names ? info.Names.toString() : "";
            if (containerNamesStr[0] == '/') {
              containerNamesStr = containerNamesStr.substr(1);
            }
            networkDom.find('.jvc-version').attr('name', containerNamesStr);
            networkDom.find('.container_Names').text(containerNamesStr).attr('onclick', 'refreshContainerDetails()').data('info', JSON.stringify(info));
            if (info.State == 'running' || info.State == 'restarting') {
              networkDom.find('.container_State .stateIcon').attr('src', './image/containericon/icon_move.png');
              networkDom.find('.container_State .stateText').text('运行').attr('data-lang', 'running');
              networkDom.find('.jvc-startBtnPlay').hide();
              networkDom.find('.jvc-startBtnStop').show();
            } else {
              networkDom.find('.container_State .stateIcon').attr('src', './image/containericon/icon_nomove.png');
              networkDom.find('.container_State .stateText').text('未运行').attr('data-lang', 'stopped');
              networkDom.find('.jvc-startBtnPlay').show();
              networkDom.find('.jvc-startBtnStop').hide();
            }

            networkDom.find('.container_Image').text(info.Image).attr('title', info.Image);
            networkDom.find('.container_Created').text(formatDate(info.Created * 1000));
            if (info.NetworkSettings.Networks) {
              for (var variable in info.NetworkSettings.Networks) {
                if (info.NetworkSettings.Networks.hasOwnProperty(variable)) {
                  networkDom.find('.container_IPAddress').text(info.NetworkSettings.Networks[variable].IPAddress);
                }
              }
            }

            let link = '';
            for (var j = 0; j < info.Ports.length; j++) {
              let publicPort = info.Ports[j].PublicPort == undefined ? 'auto' : info.Ports[j].PublicPort;
              let privatePort = info.Ports[j].PrivatePort == undefined ? 'auto' : info.Ports[j].PrivatePort;
              let p = publicPort + ':' + privatePort;
              info.Ports[j].IP = info.Ports[j].IP || "";
              let hostname = info.Ports[j].IP;
              if (info.Ports[j].IP == '0.0.0.0' && info.Ports[j].IP != '::') {
                hostname = globalData.hostname;
              }

              if (info.Ports[j].IP != '0.0.0.0' && info.Ports[j].IP == '::') {
                hostname = globalData.hostname;
              }

              if (info.Ports[j].IP != '0.0.0.0' && info.Ports[j].IP != '::') {
                if (info.Ports[j].IP.indexOf(':') != -1) {
                  hostname = '[' + info.Ports[j].IP + ']';
                }
              }


              let ip = 'http://' + hostname + ':' + info.Ports[j].PublicPort;
              link += '<a href="' + ip + '" target="_blank" style="display:inline-block;color:#1E88D9;margin-right:5px;" rel="nofollow noopener noreferrer">' + p + '</a>'
            }
            networkDom.find('.container_Ports').html(link || '--');

            if (!$.isEmptyObject(info.Labels)) {
              var h = '';
              for (var ls in info.Labels) {
                if (info.Labels.hasOwnProperty(ls)) {
                  h += '<div class=""><span>' + ls + ': </span><span>' + info.Labels[ls] + '</span><div>';
                }
              }
              networkDom.find('.jvc-volumeName').data('title', h).on('mouseenter', function(e) {
                $(this).find('.jvc-notes').html($(this).data('title')).show();
                var x = e.clientX;
                var y = e.clientY;
                $(this).find('.jvc-notes').css({
                  position: 'fixed',
                  left : x + 'px',
                  top: y + 'px'
                })
              })
              networkDom.find('.jvc-volumeName').on('mouseleave', function(e) {
                $(this).find('.jvc-notes').html('').hide();
              })

            }

          }

          docker_update().then(function() {});
          docker_container_upgrading();
          changeLanguage(localStorage.getItem('lang'));
          searchNetworkData("#jv-searcontainer");
          jQuery('#jv-pageList').html('');
          for (var p = 1; p <= obj.pages; p++) {
            var mi = document.createElement("li");
            jQuery(mi).text(p);
            jQuery('#jv-pageList').append(mi);

            mi.onclick = function() {
              initData.curr = jQuery(this).text();
              refreshInfo(data, count, initData.curr);
            }
          }

          $('#jv-pageitemList').children().each(function(i, e){
            e.onclick = function() {
              initData.limit = jQuery(e).text();
              refreshInfo(data, count, initData.curr);
              localStorage.setItem('limit', jQuery(this).text());
            }
          })
          getContainerUsage();
        } else {
          $('#jv-volumeNull').show();
          $('#jv-footerPage').hide();
        }

        if (obj.pages >= 1 && obj.count) {
          $("#jv-paging").show();
          $('#jv-footerPage').show();
        } else {
          $("#jv-paging").hide();
          $('#jv-footerPage').hide();
        }
        //首次不执行
        if (!first && first != undefined) {
          refreshInfo(data, count, initData.curr);
        }
      }
    });
  });

}

//容器控制
function dockerContainerControl(id, t) {

  let event = window.event || arguments.callee.caller.arguments[0];
  let ids = [];
  let type = '';
  let target = null;
  initData.delAssVol = 0;
  if (t != undefined) {
    type = t;
  } else {
    target = event.currentTarget
    type = $(target).attr('data-state');
  }

  if (id != undefined) {
    ids.push(id);
    initData.checkCount = ids.length;
  } else {
    ids = initData.deleteName;
    if (!initData.checkCount) {
      return;
    }
  }

  if (type == 'delete') {
    var confirmAction = showSecondModel({
      title: '<span data-lang="">删除容器</span>',
      oemplateName: 'jvt-confirmAction',
      id: 'jv-confirmAction',
      isShowApplicationBtn: false,
      isShowFooterBtn: true

    }, function(e) {
      if (e) {
        containerCarryOut(ids, id, type);
      }
    })

    return;
  }

  containerCarryOut(ids, id, type);

}

function isDeleteassVol() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  initData.delAssVol = +t.checked;
}

//容器操作
function containerCarryOut(ids, id, type) {
  if (ids.length) {
    for (let i = 0; i < ids.length; i++) {

      let obj = {
        url: ''
      }
      if (type == 'delete') {
        obj.url = '../api/endpoints/' + globalData.tty + '/docker/containers/' + ids[i] + '?force=true&v=' + initData.delAssVol;
        obj['type'] = 'delete';
      } else {
        obj.url = '../api/endpoints/' + globalData.tty + '/docker/containers/' + ids[i] + '/' + type;
      }

      postData(obj, {
        success: function(result) {

        },
        complete: function(xhr, textStatus) {

          if (id != undefined) {
            ids.splice(i, 1);
          } else {
            initData.deleteName.splice(i, 1);
          }

          initData.checkCount--;

        },
        error: function(xhr, textStatus) {
          console.log(xhr);
          console.log(textStatus);

        }
      },1);
    }
  }

  var t = setInterval(function() {
    if (!initData.checkCount) {
      getData();
      clearInterval(t);
      $('#jv-popup').fadeOut();
    }
  }, 50);

}

window.containerTimer = null;
//获取图像数据
function getContainerUsage() {
  var data = {
    cmd : 'docker_stats'
  }
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(res) {
      if (res.err == 0) {
        var info = res.results || {};
        var stats = info.stats || {};
        // console.log(stats);
        if (!$.isEmptyObject(stats)) {
          for (var v in stats) {
            if (stats.hasOwnProperty(v)) {
              $('#jv-d-tbodybox').children().each(function(i, e) {
                var c = $(e).data('dataInfo') || {};
                if (c.Id == v) {
                  var memUsage = stats[v].MemUsage.split("/");
                  var cpuData = parseFloat(stats[v].CPUPerc.split("%")[0]);
                  var h = 0;
                  if (cpuData > 100) {
                    h = 100;
                  } else {
                    h = cpuData == 0 ? '0.00' : cpuData;
                  }

                  $(e).find('.jvc-cupUsage').text(h+'%');
                  $(e).find('.jvc-memoryUsage').text(memUsage[0]);
                  if (cpuData > 90) {
                    seteChart($(e).find('.jvc-cupUsageEC')[0], h, '#ff4a48');
                  } else if (cpuData > 50 && cpuData <= 90) {
                    seteChart($(e).find('.jvc-cupUsageEC')[0], h, '#f3b028');
                  } else {
                    seteChart($(e).find('.jvc-cupUsageEC')[0], h, '#08cea1');
                  }

                }
              })
            }
          }
        }
      }
      clearTimeout(window.containerTimer);
      containerTimer = setTimeout(function(){
        getContainerUsage();
      }, 5000);

    },
    complete: function(event, xhr, options) {

    },
    error: function(xhr, textStatus) {

    }
  }, false);

}

//获取版本信息
function docker_update() {
  return new Promise(function(resolve, reject) {
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify({
        "cmd": "docker_update",
        "params": {
          "action": "list"
        }
      })
    }
    postData(obj, {
      success: function(result) {
        var info = result.results || {};
        if (info.update_list) {
          var images = info.update_list.images || [];
          if (images.length) {

            $('#jv-d-tbodybox').children().each(function(i, e) {
              var c = $(e).data('dataInfo');
              $(e).find('.jvc-version').attr('data-lang', 'newest');
              for (var j = 0; j < images.length; j++) {
                if (c.ImageID == images[j].ImageID && (c.Image == c.ImageID || c.Image == images[j].Image)) {
                  $(e).find('.jvc-version').attr('data-lang', 'upgradable').addClass('upgradable')
                    .on('click', function(ev) {
                      docker_container_upgrade($(ev.target).attr('name'));
                    })
                    break;
                }else {

                }
              }

            })


          } else {
            $('#jv-d-tbodybox').find('.jvc-version').attr('data-lang', 'newest');
          }

        } else {
          $('#jv-d-tbodybox').find('.jvc-version').attr('data-lang', 'newest');
        }

        changeLanguage(localStorage.getItem('lang'));
      },
      complete: function(event, xhr, options) {

      },
      error: function(xhr, textStatus) {

      }
    }, false);
  })

}


//版本升级
function docker_container_upgrade(name) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = event.target;
  return new Promise(function(resolve, reject) {
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify({
        "cmd": "docker_update",
        "params": {
          "action": "upgrade",
          "container": name
        }
      })
    }
    postData(obj, {
      success: function(result) {
        if (result.err == 0) {
          $(target).find('input').attr('disabled', true);
          $(target).css('pointer-events', 'none');
          $(target).find('.jvc-version').attr('data-lang', 'upgrading').addClass('upgrading');
          docker_container_upgrading();
        }

      },
      complete: function(event, xhr, options) {

      },
      error: function(xhr, textStatus) {

      }
    }, false);
  });

}


//升级中容器
function docker_container_upgrading() {
  var t = null;
  return new Promise(function(resolve, reject) {
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify({
        "cmd": "docker_update",
        "params": {
          "action": "upgrading"
        }
      })
    }
    postData(obj, {
      success: function(result) {
        var info = result.results || {};
        var upgrading = result.results.upgrading || [];
        if (!upgrading.length) {
          clearTimeout(t);
          $('#jv-d-tbodybox').children().each(function(i, e) {
            $(e).css('pointer-events', 'auto');
            $(e).find('input').attr('disabled', false);
            if ($(e).find('.jvc-version').attr('data-lang') != 'upgradable') {
              $(e).find('.jvc-version').off('click').attr('data-lang', 'newest');
              $(e).find('.jvc-version').attr('class', 'jvc-version');
            }
          })
        }else {
          $('#jv-d-tbodybox').children().each(function(i, e) {
            var name = $(e).find('.container_Names').text();
            if (upgrading.indexOf(name) > -1) {
              $(e).find('input').attr('disabled', true);
              $(e).css('pointer-events', 'none');
              $(e).find('.jvc-version').attr('data-lang', 'upgrading').addClass('upgrading');
            } else {
              if ($(e).find('.jvc-version').attr('data-lang') != 'upgradable') {
                $(e).find('.jvc-version').off('click').attr('data-lang', 'newest');
              }
              $(e).find('.jvc-version').removeClass('upgrading');
              $(e).css('pointer-events', 'auto');
              $(e).find('input').attr('disabled', false);
            }
          })

          t = setTimeout(function(){
            docker_container_upgrading();
          }, 10000);
        }

        changeLanguage(localStorage.getItem('lang'));
      },
      complete: function(event, xhr, options) {

      },
      error: function(xhr, textStatus) {

      }
    }, false);
  })

}

//搜索
function searchNetworkData(e) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  if (e) {
    t = e;
  }
  let v = $(t).val().trim();

  $("#jv-d-tbodybox>div:contains(" + v + ")").show();
  $("#jv-d-tbodybox>div:not(:contains(" + v + "))").hide();
}

// 全选
function checkboxAll() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  initData.deleteName = [];
  if (t.checked) {
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      if (!$(e).prop('disabled')) {
        e.checked = true;
      }
      initData.deleteName.push($(e).data('dataInfo').Id)
      initData.checkCount++;
    })
  } else {
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      e.checked = false;
      initData.deleteName = [];
      initData.checkCount = 0;
    })
  }
}

// 单选
function checkboxSelect() {

  let event = window.event || arguments.callee.caller.arguments[0];
  let len = $('#jv-d-tbodybox').find('.jvc-checkbox').length;
  initData.checkCount = 0;
  initData.deleteName = [];
  $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
    if (e.checked) {
      initData.checkCount++;
      initData.deleteName.push($(e).data('dataInfo').Id);
    }
  })
  if (initData.checkCount == len) {
    $('#jv-checkboxAll').prop("checked", true);
  } else {
    $('#jv-checkboxAll').prop("checked", false);
  }

}

function seteChart(t, v, bg) {
  var chart = echarts.init(t);
  var option = {
    series: [{
      type: 'gauge',
      startAngle: -270,
      endAngle: 90,
      min: 0,
      max: 100,
      splitNumber: 1,
      center: ['50%', '50%'],
      radius: '90%',
      itemStyle: {
        color: bg,
      },
      progress: {
        show: true,
        width: 4,
      },
      axisLine: {
        color: '#e9e9e9',
        lineStyle: {
          width: 4,
        }
      },
      axisTick: {
        show: false
      },
      pointer: {
        show: false
      },
      splitLine: {
        show: false,
      },
      axisLabel: {
        show: false
      },
      detail: {
        show: false,
      },
      data: [{
        value: v
      }]
    }]
  };
  option && chart.setOption(option);
}
