SPA_RESOLVE_INIT = function(transition) {
  // document.getElementById("content").innerHTML = '<p style="color:#099fde;">当前异步渲染首页'+ JSON.stringify(transition) +'</p>'

}

SPA_RESOLVE_HTML = function(transition) {

}
var runningContainer = [];

$('body').on('click', '.homeNavItem', function(e) {
  let t = $(e.currentTarget);
  let i = $(e.currentTarget).index();

  $('.navItem').each(function(i, ev) {
    if ($(ev).find('a').attr('href') == t.attr('href')) {
      let srcEv = $(ev).find('img').attr('src');
      $(ev).addClass('currentNav');
      // $(ev).find('img').attr('src', srcEv.substring(0, (srcEv.length - 5)) + 'y.png');
      $('#jv-headerTitle').text($(ev).text());
    } else {
      let srcEv = $(ev).find('img').attr('src');
      $(ev).removeClass('currentNav');
      // $(ev).find('img').attr('src', srcEv.substring(0, (srcEv.length - 5)) + 'n.png');
    }
  })

})

function getDockerInfo() {
  let obj = {
    url: '../api/endpoints/1/docker/info', //接口
    type: "get"
  }
  postData(obj, {
    success: function(result) {
      if (result) {

        $('#xtxgItem_Rootdirectory').html(result.DockerRootDir);
        $('#xtxgItem_system').html(result.OperatingSystem);
        $('#dockerCUP').html(result.NCPU);
        $('#dockerRAM').html(formSize(result.MemTotal));
        $('#dockerOS').html(result.ServerVersion);
        $('#ContainersId').html(result.Containers);
        $('#MirroringId').html(result.Images);
      }

    }, //回调成功方法
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  })
}

function getContainers() {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/json?all=1',
    type: "get",
  }
  return new Promise(function(resolve, reject) {
    postData(obj, {
      success: function(result) {
        var running = 1;
        if (result) {
          for (var i = 0; i < result.length; i++) {
            var tp = result[i];
            var info = result[i];
            if (tp.State == 'running') {
              running = 0;
              runningContainer.push(tp);
              var cDom = wfTemplateAppend('#jv-rq-host', 'jvt-rq-item', 'jvt-rq-item' + i);
              let containerNamesStr = tp.Names ? tp.Names.toString() : "";
              if (containerNamesStr[0] == '/') {
                containerNamesStr = containerNamesStr.substr(1);
              }
              cDom.data('cInfo', tp);
              cDom.find('.jvc-devpah').text(containerNamesStr);
              // refreshEchartsData(tp.Id);
              let link = '';
              for (var j = 0; j < info.Ports.length; j++) {
                let publicPort = info.Ports[j].PublicPort == undefined ? 'auto' : info.Ports[j].PublicPort;
                let privatePort = info.Ports[j].PrivatePort == undefined ? 'auto' : info.Ports[j].PrivatePort;
                let p = publicPort + ':' + privatePort;
                info.Ports[j].IP = info.Ports[j].IP || "";
                let hostname = info.Ports[j].IP;
                if (info.Ports[j].IP == '0.0.0.0' && info.Ports[j].IP != '::') {
                  hostname = globalData.hostname;
                }

                if (info.Ports[j].IP != '0.0.0.0' && info.Ports[j].IP == '::') {
                  hostname = globalData.hostname;
                }

                if (info.Ports[j].IP != '0.0.0.0' && info.Ports[j].IP != '::') {
                  if (info.Ports[j].IP.indexOf(':') != -1) {
                    hostname = '[' + info.Ports[j].IP + ']';
                  }
                }


                let ip = 'http://' + hostname + ':' + info.Ports[j].PublicPort;
                link += '<a href="' + ip + '" target="_blank" style="display:inline-block;color:#1E88D9;margin-right:5px;" rel="nofollow noopener noreferrer">' + p + '</a>'
              }
              cDom.find('.container_Ports').html(link || '--');
            }
          }
          refreshEchartsData_home();
          if (running) {
            $('#jv-rq-container').hide();
          }
        } else {
          $('#jv-rq-container').hide();
        }
        resolve(resolve);
        changeLanguage(localStorage.getItem('lang'));

      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  }).then(function(res) {
    if (res.length) {

    } else {
      $('#jv-rq-container').hide();
    }
  })

}

//获取图像数据
function refreshEchartsData_old(id) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + id + '/stats?stream=false',
    type: 'get'
  }
  postData(obj, {
    success: function(result) {
      // console.log(result);
      if (result) {
        var cpuData = (result.cpu_stats.cpu_usage.total_usage - result.precpu_stats.cpu_usage.total_usage) / (result.cpu_stats.system_cpu_usage - result.precpu_stats.system_cpu_usage) * result.cpu_stats.online_cpus * 100;
        var memory = 0,
          cache = 0;
        if ($.isEmptyObject(result.memory_stats) != true) {
          cache = result.memory_stats.stats.cache || 0;
          memory = result.memory_stats.usage - cache;
        }
        $('#jv-rq-host').children().each(function(i, e) {
          var c = $(e).data('cInfo');
          if (c.Id == id) {
            $(e).find('.jvc-cpu-usage').text(cpuData.toFixed(2) + '%');
            $(e).find('.jvc-memory-usage').text(formSize(memory));
            var h = 0;
            if (cpuData > 100) {
              h = 100;
            } else {
              h = cpuData;
            }

            if (cpuData) {
              $(e).find('.lui-inner').css('height', h + '%');
              if (cpuData > 90) {
                $(e).find('.lui-column-bg').attr('class', 'lui-column-bg lui-column-re');
              } else if (cpuData > 50 && cpuData < 90) {
                $(e).find('.lui-column-bg').attr('class', 'lui-column-bg lui-column-or');
              } else {
                $(e).find('.lui-column-bg').attr('class', 'lui-column-bg lui-column-gr');
              }
            }

          }
        })
      }
    },
    complete: function(event, xhr, options) {

    },
    error: function(xhr, textStatus) {

    }
  }, false);

}

window.containerHomeTimer = null;
//获取图像数据
function refreshEchartsData_home() {
  var data = {
    cmd : 'docker_stats'
  }
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(res) {
      if (res.err == 0) {
        var info = res.results || {};
        var stats = info.stats || {};

        if (!$.isEmptyObject(stats)) {
          for (var v in stats) {
            if (stats.hasOwnProperty(v)) {
              $('#jv-rq-host').children().each(function(i, e) {
                var c = $(e).data('cInfo');
                if (c.Id == v) {
                  var memUsage = stats[v].MemUsage.split("/");
                  var cpuData = parseFloat(stats[v].CPUPerc.split("%")[0]).toFixed(2);

                  $(e).find('.jvc-cpu-usage').text(stats[v].CPUPerc);
                  $(e).find('.jvc-memory-usage').text(memUsage[0]);
                  var h = 0;
                  if (cpuData > 100) {
                    h = 100;
                  } else {
                    h = cpuData;
                  }

                  if (cpuData > 0.01) {
                    $(e).find('.lui-inner').css('height', h + '%');
                    if (cpuData > 90) {
                      $(e).find('.lui-column-bg').attr('class', 'lui-column-bg lui-column-re');
                    } else if (cpuData > 50 && cpuData < 90) {
                      $(e).find('.lui-column-bg').attr('class', 'lui-column-bg lui-column-or');
                    } else {
                      $(e).find('.lui-column-bg').attr('class', 'lui-column-bg lui-column-gr');
                    }
                  }

                }
              })

            }
          }
        }
      }
      if ($('#jv-rq-container').length) {
        clearTimeout(window.containerHomeTimer);
        containerHomeTimer = setTimeout(function(){
          refreshEchartsData_home();
        }, 5000);
      }else {
        clearTimeout(window.containerHomeTimer);
      }

    },
    complete: function(event, xhr, options) {

    },
    error: function(xhr, textStatus) {

    }
  }, false);

}

function getDockerVolumes() {
  let obj = {
    url: '../api/endpoints/1/docker/volumes', //接口
    type: "get"
  }
  postData(obj, {
    success: function(result) {
      if (result) {
        $('#volumeId').html(result.Volumes.length);
      }

    }, //回调成功方法
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  })

}

function getDockerNetworks() {
  let obj = {
    url: '../api/endpoints/1/docker/networks', //接口
    type: "get"
  }
  postData(obj, {
    success: function(result) {
      if (result) {
        $('#InternetId').html(result.length);
      }
    }, //回调成功方法
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  })

}




(function() {
  'use strict'
  $(document).ready(function() {
    getDockerInfo();
    getDockerVolumes();
    getDockerNetworks();
    getContainers();
    let lang = localStorage.getItem('lang');
    changeLanguage(lang);
  })
}())
