SPA_RESOLVE_INIT = function(transition) {}
SPA_RESOLVE_HTML = function(transition) {}

var file = null;
var fileType = '';
var that = null;
var _sher = null;
var imageDetailsId = '';
var initData = {
  list: [], //列表数据
  count: 0, //列表总数
  curr: 1, //当前页
  limit: 100000000, //每页数量
  checkCount: 0, //已选列表数量
  deleteName: [], //保存删除列表名称
  pullingList: []
}
var filtermodle = 'all';
var registriesType = 'simple'; //拉取镜像类型
var imageNameInfo = null;
var pullingOutTime = null;
var docker_pullingOutTime = null;
globalData.hashName = location.hash.split("?")[0].split("#")[1];
var editContainerInfo = {};
//获取*镜像来源:
function getRegistries_img(that) {
  var data = {
    cmd : 'docker_registries',
    "token": getCookie('PHPSESSID') || "",
  }
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(res) {
      var result = res.results.registry || [];
      var dft = res.results.default;
      if (result.length) {
        that.find('.selectControl').empty();

        if (dft == 0) {
          that.find('.selectControl').append('<option value="0" selected>DockerHub</option>');
        }else {
          that.find('.selectControl').append('<option value="0" >DockerHub</option>');
        }

        let dom = '';
        for (let i = 0; i < result.length; i++) {
          if (dft == result[i].Id) {
            dom += '<option value=' + result[i].Id + ' selected>' + result[i].Name + '</option>';
          }else {
            dom += '<option value=' + result[i].Id + '>' + result[i].Name + '</option>';
          }

        }
        that.find('.selectControl').append(dom);

        that.find('.selectControl').off( "change").on('change', function(){
          registryDefault(that, $(this).val(), function(){
            getRegistries_img(that);
          });
        })

      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

function registriesPointer() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let href = $('#jv-registriesSearch').attr('href');
  if ($(t).val()) {
    href += $(t).val();
    that.find('#jv-registriesSearch').attr('href', href);
  } else {
    that.find('#jv-registriesSearch').attr('href', '../hub/search?type=image&q=');
  }
}

// 获取镜像列表数据
function initImageData() {
  return new Promise(function(resolve, reject) {
    let obj = {
      url: '../api/endpoints/' + globalData.tty + '/docker/containers/json?all=1',
      type: "get",
    }
    postData(obj, {
      success: function(result) {
        if (result) {
          resolve(result);
        }

      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })

}


function upData(arr) {

  initImageData().then(function(res) {

    getImglist().then(function(result) {
      if (result) {
        initData.list = result;
        initData.count = result.length;
        for (var j = 0; j < result.length; j++) {
          result[j].used = false;
          result[j].pulling = 0;
          for (var i = 0; i < res.length; i++) {
            if (res[i].ImageID == result[j].Id) {
              result[j].used = true;
            }
          }
        }

        var t = [];
        if (arr != undefined) {
          for (var i = 0; i < arr.length; i++) {
            arr[i].pulling = 1;
          }
          t = arr.concat(result);
        }else {
          t = result;
        }

        refreshInfo(t, initData.count, initData.curr);

      }

    })

  });
}

function getImglist() {
  return new Promise(function(resolve, reject) {
    let obj = {
      url: '../api/endpoints/' + globalData.tty + '/docker/images/json?all=0',
      type: "get",
    }

    postData(obj, {
      success: function(result) {
        resolve(result);

      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    }, false)
  })
}


//数据更新
function refreshInfo(data, count, curr) {

  layui.use('laypage', function() {
    var laypage = layui.laypage;
    laypage.render({
      elem: 'jv-paging',
      count: count, //数据总数，从服务端得到,
      limit: initData.limit,
      curr: curr,
      prev: ' ', //若不显示，设置false即可
      next: ' ', //若不显示，设置false即可
      jump: function(obj, first) {
        //obj包含了当前分页的所有参数，比如：
        // obj.limit 得到每页显示的条数
        initData.curr = obj.curr; //得到当前页，以便向服务端请求对应页的数据。
        $('#jv-gopage').text(obj.curr);
        $('#jv-pageitemV').text(initData.limit);
        let t = arrTrans(initData.limit, data);
        $('#jv-d-tbodybox').empty();
        $('#jv-checkboxAll').prop("checked", false);
        if (data.length) {
          var len = t[initData.curr - 1].length;
          var ispulling = 0;
          for (var i = 0; i < len; i++) {
            let info = t[initData.curr - 1][i];
            info.RepoTags = info.RepoTags || [];
            info.RepoDigests = info.RepoDigests || [];
            var networkDom = wfTemplateAppend('#jv-d-tbodybox', 'jvt-d-tr', 'jvt-d-tr' + i);

            if (!info.pulling) {
              let imageName = '';

              imageName = info.RepoDigests.length ? info.RepoDigests[0].split('@')[0] : info.RepoTags[0].split(':')[0];

              if (info.used) {
                networkDom.find('.jvc-used').addClass('used-img').attr('data-lang',"used").text(_('used'));
              }else {
                networkDom.find('.jvc-used').removeClass('used-img').text('').attr('data-lang',"");
              }

              if (imageName.startsWith('dockerpull.u-nas.com/library/')) {
                imageName = imageName.slice('dockerpull.u-nas.com/library/'.length);
              }else if (imageName.startsWith('dockerpull.u-nas.com/')) {
                imageName = imageName.slice('dockerpull.u-nas.com/'.length);
              }

              networkDom.find('.imageName').html(imageName).attr('title', imageName);
              networkDom.find('.jvc-checkbox').data('dataInfo', info);
              networkDom.find('.image_Id').text(info.Id).attr('onclick', 'imageDetails("' + info.Id + '")').attr('title', info.Id);
              networkDom.find('.image_RepoTags').text(info.RepoTags).attr('title', info.RepoTags);
              networkDom.find('.image_Size').text(formSize(info.Size)).show();
              networkDom.find('.image_Created').text(formatDate(info.Created * 1000));
              networkDom.find('.actionsExport').attr('onclick', 'exportImage("' + info.RepoTags[0] + '")');
              networkDom.find('.actionsDeleteUn').data('dataInfo', info);
              networkDom.find('.actionsDelete').data('dataInfo', info);
              networkDom.find('.createImageContainer').data('dataInfo', info);
              networkDom.find('.imag_linkicon').data('data-imageName', imageName);
              networkDom.find('.pullingBtn').show();
              networkDom.find('.actionsCancel').hide();
              var oldtool_tip = document.querySelector(".tool_tip");
              if (oldtool_tip) {
                document.body.removeChild(oldtool_tip);
              }
            } else {
              var pullingProgress = info.t.trim().split('\r');
              pullingProgress = pullingProgress[pullingProgress.length -1];
              networkDom.attr('data-type', 'pulling');
              var imageName = info.image.split(':')[0];
              if (imageName.startsWith('dockerpull.u-nas.com/library/')) {
                imageName = imageName.slice('dockerpull.u-nas.com/library/'.length);
              }else if (imageName.startsWith('dockerpull.u-nas.com/')) {
                imageName = imageName.slice('dockerpull.u-nas.com/'.length);
              }
              networkDom.find('.imageName').html(imageName);
              networkDom.find('.image_progress').show();
              if (pullingProgress) {
                networkDom.find('.image_progress img').hide();
                networkDom.find('.image_progress .marquee').show()
                networkDom.find('.image_progress .progressStatus').text(pullingProgress);
              }else {
                networkDom.find('.image_progress img').show();
                networkDom.find('.image_progress .marquee').hide();
              }
              networkDom.find('.jvc-used').text('').attr('data-lang',"");
              networkDom.find('.image_RepoTags').text(info.image).attr('title', info.image);
              networkDom.find('.jvc-checkbox').attr('disabled', 'disabled');
              networkDom.find('.image_Created').text(formatDate(info.start * 1000));
              networkDom.find('.pullingBtn').hide();
              // networkDom.find('.pullingProgress').attr('title', info.t);
              networkDom.find('.pullingProgress').attr('data-tip', info.t).attr('data-direction', "top");
              networkDom.find('.actionsCancel').show().data('dataInfo', info);
              ispulling = 1;
              var oldtool_tip = document.querySelector(".tool_tip");
              if (oldtool_tip) {
                  document.body.removeChild(oldtool_tip);
                }
              tooltip('.pullingProgress', {transition: true, time: 1}, function(){}, function(e){});
          }

          }

          // if (ispulling) {
          //   $('#jv-d-tbodybox').find('.jvc-pullingBtn').css('pointer-events', 'none');
          // } else {
          //   $('#jv-d-tbodybox').find('.jvc-pullingBtn').css('pointer-events', 'auto');
          // }
          searchNetworkData('#jv-imagesear');
          jQuery('#jv-pageList').html('');
          for (var p = 1; p <= obj.pages; p++) {
            var mi = document.createElement("li");
            jQuery(mi).text(p);
            jQuery('#jv-pageList').append(mi);

            mi.onclick = function() {
              initData.curr = jQuery(this).text();
              refreshInfo(data, count, initData.curr);
            }

          }
          $('#jv-pageitemList').children().each(function(i, e){
            e.onclick = function() {
              initData.limit = jQuery(e).text();
              refreshInfo(data, count, initData.curr);
            }
          })
          $('#jv-volumeNull').hide();
        } else {
          $('#jv-volumeNull').show();
          $('#jv-footerPage').hide();
        }

        if (obj.pages >= 1 && obj.count) {
          $("#jv-paging").show();
          $('#jv-footerPage').show();
        } else {
          $("#jv-paging").hide();
          $('#jv-footerPage').hide();
        }
        //首次不执行
        if (!first) {
          refreshInfo(data, count, initData.curr);
        }
      }
    });
  });

  filtermodle = localStorage.getItem('filtermodle') || 'all';

  if (filtermodle == 'all') {
    $("#jv-d-tbodybox>div:contains()").show();
  }else {
    if (filtermodle == 'unused') {
      $("#jv-d-tbodybox>div:contains()").show();
      $("#jv-d-tbodybox>div:contains(" + _('used') + ")").hide();
    }else {
      $("#jv-d-tbodybox>div:contains(" + _(filtermodle) + ")").show();
      $("#jv-d-tbodybox>div:not(:contains(" + _(filtermodle) + "))").hide();
    }

  }
}

// 删除镜像列表
function deleteImageItem(force, un) {
  if (!initData.checkCount) {
    $('#jv-checkboxAll').prop("checked", false);
    return;
  }

  if (un == 'unused') {
    initData.deleteName = [];
    initData.checkCount = 0;
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      if (e.checked) {
        let checkedInfo = $(e).data('dataInfo');
        if (!checkedInfo.used) {
          initData.deleteName.push(checkedInfo.Id);
          initData.checkCount++;
        }
      }
    })
  }

  if (initData.deleteName.length) {
    for (let i = 0; i < initData.deleteName.length; i++) {

      let obj = {
        url: '../api/endpoints/' + globalData.tty + '/docker/images/' + initData.deleteName[i] + '?force=' + force,
        type: 'DELETE'
      }

      postData(obj, {
        success: function(result) {
          // console.log(result);
        },
        complete: function(xhr, textStatus) {
          initData.deleteName.splice(i, 1);
          initData.checkCount--;
        },
        error: function(xhr, textStatus) {
          // errorMessageBox('文件不合法！');
          // JSON.parse()
          console.log(xhr);
          console.log(textStatus);

        }
      });
    }
  }

  var t = setInterval(function() {
    if (!initData.checkCount) {
      upData();
      clearInterval(t);
    }
  }, 50);

}

//搜索
function searchNetworkData(e) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  if (e) {
    t = e;
  }
  let v = $(t).val().trim();

  $("#jv-d-tbodybox>div:contains(" + v + ")").show();
  $("#jv-d-tbodybox>div:not(:contains(" + v + "))").hide();
}

// 导入镜像文件
function importFile() {

  var that_import_file = showModel({
    title: '<span data-lang="import">导入</span>',
    oemplateName: 'jvt-importFile',
    id: 'jv-importFile',
    isShowApplicationBtn: false,
    isShowFooterBtn: true,
    btnText2: '导入',
    btnLang: 'import',
    btnStlye: {
      background: '#FF7978',
      border: '1px solid #FF7978'
    }

  }, function(e) {
    if (e) {
      var dir = that_import_file.find('.listInfoItemVal').val();
      var lt = dir.split('/');
      var filename = lt[lt.length - 1];
      var ishf = 1;
      if (!dir) {
        errorMessageBox('请选择要导入的文件！');
        return;
      }

      for (var i = 0; i < fileListType.length; i++) {
        if (filename == fileListType[i]) {
          ishf = 0;
        }
      }
      if (ishf) {
        errorMessageBox('文件不合法！');
        return
      }
      docker_image_import(dir);
    }
  })
  that_import_file.parent('.modal-content').css('overflow', 'inherit');
  that_import_file.find('.jvc-localUpload').attr('onclick', 'importImage();');
  dir_file = 'import';
}
//导入unas镜像
function docker_image_import(filename) {
  return new Promise(function(resolve, reject) {
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_image_import",
      "params": {
        "tar_file": filename,
      }
    };
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }

    postData(obj, {
      success: function(result) {
        upData();
        closePopup();
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })

}


// 导入镜像
function importImage() {

  showModel({
    title: '<span data-lang="importImage">导入镜像</span>',
    oemplateName: 'jvt-selectImageFile',
    id: 'jv-selectImageFile',
    isShowApplicationBtn: false,
    isShowFooterBtn: true

  }, function(e) {
    if (e) {
      if (!file) {
        return;
      }
      showLoading();
      $.ajax({
        url: '../api/endpoints/' + globalData.tty + '/docker/images/load', //接口
        type: "post", //GET或POST
        data: file,
        headers: {
          'Content-Type': file.type
        },
        processData: false, // 不处理发送的数据，因为data值是Formdata对象，不需要对数据做处理
        contentType: false, // 不设置Content-type请求头
        dataType: 'json',
        success: function(result) {
          upData();
          closePopup();
          hideLoading();
        }, //回调成功方法
        error: function(xhr, textStatus) {
          console.log(xhr);
          console.log(textStatus);
          hideLoading();
        }
      });
    }
  })

}
// 上传文件
function selectFile() {
  $('#jv-file').change(function(e) {
    file = e.target.files[0];
    fileType = $("#jv-file").val().split(".").slice(-1);
    $(".filetext").text(file.name);
  });
  $('#jv-file').click();
}

//导出镜像
function exportImage(n) {

  let names = '';
  var unas = [];
  if (n == undefined) {
    $('#jv-d-tbodybox').children().each(function(i, e) {
      let box = $(e).find('.jvc-checkbox')[0];
      if (box.checked) {
        let checkedInfo = $(box).data('dataInfo');
        names += 'names=' + $(e).find('.image_RepoTags').text() + '&';
        if ($(e).find('.image_RepoTags').text()) {
          let tep = $(e).find('.image_RepoTags').text().split(',')[0];
          unas.push(tep);
        }
      }
    })
    names = names.substring(0, names.length - 1);
    if (!names.length) {
      errorMessageBox('请选择要导出的镜像！');
      return;
    }
  } else {
    names = 'names=' + n + '&';
    if (n) {
      let tep = n.split(',')[0];
      unas.push(tep);
    }

  }


  var thatExportContainer = showModel({
    title: '<span data-lang="export">导出</span>',
    oemplateName: 'jvt-exportContainer',
    id: 'jv-exportContainer',
    isShowApplicationBtn: false,
    isShowFooterBtn: true,
    btnText2: '导出',
    btnLang: 'export',
    btnStlye: {
      background: '#FF7978',
      border: '1px solid #FF7978'
    }

  }, function(e) {
    if (e) {
      var dir = thatExportContainer.find('.listInfoItemVal').val();
      if (!dir) {
        errorMessageBox('请选择要导出的文件位置！');
        return;
      }
      if (unas.length) {
        docker_image_export(unas, dir);
      } else {
        errorMessageBox('请选择要导出的镜像！');
      }

    }
  })
  thatExportContainer.parent('.modal-content').css('overflow', 'inherit');
  thatExportContainer.find('.jvc-localUpload').on('click', function() {
    if (names) {
      downloadFile('../api/endpoints/' + globalData.tty + '/docker/images/get?' + names, 'image');
    } else {
      errorMessageBox('请选择要导出的镜像！');
    }
  });
  dir_file = 'export';

}

function functionName(n) {

}


//镜像导出到unas
function docker_image_export(imagename, dir) {
  return new Promise(function(resolve, reject) {
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_image_export",
      "params": {
        "images": imagename,
        "target_dir": dir
      }
    };
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }

    postData(obj, {
      success: function(result) {

        closePopup();
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })

}


// 拉取镜像
function pullImageModel() {
  that = showModel({
    title: '<span data-lang="pullImageModel">拉取镜像</span>',
    oemplateName: 'jvt-imagepull',
    id: 'jv-imagepull',
    isShowApplicationBtn: false,
    isShowFooterBtn: true,
    closeBtn : false

  }, function(e) {
    if (e) {
      // pullImage_(that);
      closePopup();
    }
  })

  getRegistries_img(that);

  that.find('#jv-pullbtn').click(function(e) {
    pullImage_(that);
  })

  that.find('.topNavBtnList .navBtnItem, .goback').click(function(e) {
    that.find('#jv-registriesImageItem').show();
    that.find('#jv-searchImageItem').hide();
    that.find('.goback').hide();
    that.find('#jv-searchImageBtn').removeClass('selectnavBtnItem');
    $('#jv-box-footer').show();
    registriesType = $(this).attr('data-type');
    that.find('#jv-nullimages').hide();
    if (registriesType == 'search') {
      return;
    }

    // $(this).addClass('selectnavBtnItem').siblings().removeClass('selectnavBtnItem');
    // if (registriesType == 'senior') {
    //   that.find('.jvc-registriesinputItem').slideUp();
    // } else {
    //   that.find('.jvc-registriesinputItem').slideDown();
    // }
  })

  that.find("#jv-imagesname").on('click', function(){
    var tbody=that.find('#jv-imageListHost');
    var rows=tbody.children('div');
    rows=Array.prototype.slice.call(rows,0);

    if (jQuery(this).attr('type') == 'ascending') {
      jQuery(this).attr('type', 'descending')
      .removeClass('ascending').addClass('descending');
      rows.sort(function(row1,row2){
          var val1 = $(row1).find('.name').text();
          var val2 = $(row2).find('.name').text();
          if(val2>val1){
              return 1;
          }else if(val2<val1){
              return -1;
          }else{
              return 0;
          }
      });

    }else {
      jQuery(this).attr('type', 'ascending')
      .removeClass('descending').addClass('ascending');
      rows.sort(function(row1,row2){
          var val1 = $(row1).find('.name').text();
          var val2 = $(row2).find('.name').text();
          if(val1>val2){
              return 1;
          }else if(val1<val2){
              return -1;
          }else{
              return 0;
          }
      });
    }
    tbody.append(rows);
  })

  that.find("#jv-starstor").on('click', function(){
    var tbody=that.find('#jv-imageListHost');
    var rows=tbody.children('div');
    rows=Array.prototype.slice.call(rows,0);

    if (jQuery(this).attr('type') == 'ascending') {
      jQuery(this).attr('type', 'descending')
      .removeClass('ascending').addClass('descending');
      rows.sort(function(row1,row2){
          var val1 = +$(row1).find('.stars').text();
          var val2 = +$(row2).find('.stars').text();
          if(val2>val1){
              return 1;
          }else if(val2<val1){
              return -1;
          }else{
              return 0;
          }
      });

    }else {
      jQuery(this).attr('type', 'ascending')
      .removeClass('descending').addClass('ascending');
      rows.sort(function(row1,row2){
          var val1 = +$(row1).find('.stars').text();
          var val2 = +$(row2).find('.stars').text();
          if(val1>val2){
              return 1;
          }else if(val1<val2){
              return -1;
          }else{
              return 0;
          }
      });
    }
    tbody.append(rows);
  })

}

function pullImage_(that) {
  var registriesName = that.find("input[name='registriesName']").val().toLowerCase();
  let fromImage = registriesName;
  let data = {
    fromImage: ''
  }
  if (!fromImage) {
    errorMessageBox('请题写镜像名称');
    return;
  }

  // if (registriesType == 'simple') {
  //   if (imageNameInfo != null) {
  //     fromImage = imageNameInfo.URL + '/' + fromImage;
  //   }
  //
  //   if (imageNameInfo != null && registriesName.indexOf('/') == -1) {
  //     fromImage = imageNameInfo.URL + '/library/' + registriesName;
  //   }
  //
  //   if (registriesName.indexOf(':') == -1) {
  //     fromImage = fromImage + ':latest';
  //   }
  // }
  //
  // if (registriesType == 'senior') {
  //   fromImage = that.find("input[name='registriesName']").val();
  // }
  // data.fromImage = fromImage;

  // let obj = {
  //   url: '../api/endpoints/' + globalData.tty + '/docker/images/create?fromImage=' + encodeURIComponent(fromImage),
  //   data: JSON.stringify(data)
  // }
  let fromimgdata = {
    "token": getCookie('PHPSESSID') || "",
    "cmd": "docker_pull",
    "params": {
      "image": fromImage.replace(/\s+/g, ''),
      "action": 'start'
    }
  }

  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(fromimgdata)
  }

  postData(obj, {
    success: function(result) {
      if (result.err == 0) {

      }
      imageNameInfo = null;
      docker_pulling();
    },
    complete: function() {
      upData();
      closePopup();
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });
}

function selectControl() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let v = $(t).val();

  if (v == 'DockerHub') {
    imageNameInfo = null;
  } else {
    imageNameInfo = JSON.parse(v);
  }
}


//拉取标签镜像
function pullLasbleImage() {
  that = showSecondModel({
    title: '<span data-lang="pullImageModel">拉取镜像</span>',
    oemplateName: 'jvt-lableimagepull',
    id: 'jv-lableimagepull',
    isShowApplicationBtn: false,
    isShowFooterBtn: true

  }, function(e) {
    if (e) {
      pullImage_(that);
    }
  })

  getRegistries_img(that);

  that.find('.topNavBtnList .navBtnItem').click(function(e) {
    $(this).addClass('selectnavBtnItem').siblings().removeClass('selectnavBtnItem');
    registriesType = $(this).attr('data-type');
    if (registriesType == 'senior') {
      that.find('.jvc-registriesinputItem').slideUp();
    } else {
      that.find('.jvc-registriesinputItem').slideDown();
    }
  })
}

//查看镜像详情
function imageDetails(id) {

  that = showModel({
    title: '<span data-lang="imageDetails">镜像详情</span>',
    oemplateName: 'jvt-imageDetails',
    id: 'jv-imageDetails',
    isShowApplicationBtn: false,
    isShowFooterBtn: false

  }, function(e) {})

  getImageDetails(id);
  getImageLaeys(id);

  that.find('#jv-imageDetailsdelete').click(function() {
    let obj = {
      url: '../api/endpoints/' + globalData.tty + '/docker/images/' + $(this).data('info').Id + '?force=false',
      type: 'DELETE'
    }
    postData(obj, {
      success: function(result) {
        closePopup();
        upData();
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });

  })


  _sher = that;
}
//拉取
function imagePull(imageName, type) {
  let action = "start";

  if (type != undefined && type == 'stop') {
    action = "stop";
    clearInterval(pullingOutTime);
    clearInterval(pullingOutTime);
  }

  let data = {
    "token": getCookie('PHPSESSID') || "",
    "cmd": "docker_pull",
    "params": {
      "image": imageName,
      "action": action
    }
  }

  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {},
    complete: function() {
      if (action == "start") {
        setTimeout(function(){
          docker_pulling();
        },1000);
        errorMessageBox('Pulling');
      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });
}

//推送
function imagePush(imageName) {

  let data = {
    imageName: imageName
  }

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/images/' + imageName + '/push',
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      if (result) {

      }
    },
    complete: function() {
      upData();
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });
}
//添加标签
function addTag(id) {
  let repo = _sher.find("#jv-addTag input[name='registriesName']").val();

  if (!repo) {
    return;
  }
  let data = {
    id: id,
    repo: repo
  }

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/images/' + id + '/tag?force=0&repo=' + repo,
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      if (result) {

      }
    },
    complete: function() {
      upData();
      getImageDetails(id);
      _sher.find("#jv-addTag input[name='registriesName']").val('');
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });
}
//获取镜像详情
function getImageDetails(id) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/images/' + id + '/json',
    type: 'get'
  }

  postData(obj, {
    success: function(result) {
      imageDetailsId = result.Id;
      that.find('#jv-repoTagsListHost').empty();
      if (result) {
        for (let i = 0; i < result.RepoTags.length; i++) {
          var repoTagsDom = wfTemplateAppend(that.find('#jv-repoTagsListHost'), 'jvt-repoTagsItem', 'jvt-repoTagsItem' + i);
          repoTagsDom.find('.biaoqval').text(result.RepoTags[i]);
          repoTagsDom.find('.deleteBtn').attr('onclick', 'deleteLabel("' + result.RepoTags[i] + '")');
          repoTagsDom.find('.jvc-push').attr('onclick', 'imagePush("' + result.RepoTags[i] + '")');
          repoTagsDom.find('.jvc-pull').attr('onclick', 'imagePull("' + result.RepoTags[i] + '")');
        }

        that.find('.editBtn').attr('onclick', 'addTag("' + result.Id + '")');
        that.find('.jvc-imageId').text(result.Id).attr('title', result.Id);
        that.find('.jvc-imageSize').text(formSize(result.Size));
        that.find('.jvc-imageCreated').text(result.Created);
        let build = 'Docker ' + result.DockerVersion + ' on ' + result.Os + ', ' + result.Architecture;
        that.find('.jvc-imageBuild').text(build);
        that.find('.jvc-imageCmd').text(result.Config.Cmd);
        that.find('.jvc-imageEnv').text(result.Config.Env).attr('title', result.Config.Env);
        that.find('#jv-imageDetailsExport').attr('onclick', 'exportImage("' + result.RepoTags + '")');
        that.find('#jv-imageDetailsdelete').data('info', result);
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

// 删除标签
function deleteLabel(labelName) {

  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/images/' + labelName + '?force=false',
    type: 'DELETE'
  }
  postData(obj, {
    success: function(result) {
      upData();
      getImageDetails(imageDetailsId);
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

//获取镜像层列表
function getImageLaeys(id) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/images/' + id + '/history',
    type: 'get'
  }

  postData(obj, {
    success: function(result) {
      that.find('#jv-imageLaeysHost').empty();
      let number = 1;
      if (result) {
        for (let i = result.length - 1; i >= 0; i--) {
          let info = result[i];
          var mageLaeyskDom = wfTemplateAppend(that.find('#jv-imageLaeysHost'), 'jvt-imageLaeysItem', 'jvt-imageLaeysItem' + i);
          mageLaeyskDom.find('.jvc-imageLaeysNumber').text(number);
          mageLaeyskDom.find('.jvc-imageLaeysSize').text(formSize(info.Size));
          if (info.CreatedBy.indexOf('/bin/sh -c #(nop)') == -1) {
            mageLaeyskDom.find('.jvc-imageLaeysCreatedBy').text(info.CreatedBy);
          } else {
            mageLaeyskDom.find('.jvc-imageLaeysCreatedBy').text(info.CreatedBy.substring(17, info.CreatedBy.length));
          }
          number++;
        }
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

// 全选
function checkboxAll() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  initData.deleteName = [];
  initData.checkCount = 0;
  if (t.checked) {
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      e.checked = true;
      initData.deleteName.push($(e).data('dataInfo').Id);
      initData.checkCount++;
    })
  } else {
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      e.checked = false;
      initData.deleteName = [];
      initData.checkCount = 0;
    })
  }
}

// 单选
function checkboxSelect() {

  let event = window.event || arguments.callee.caller.arguments[0];
  let len = $('#jv-d-tbodybox').find('.jvc-checkbox').length;
  initData.checkCount = 0;
  initData.deleteName = [];
  $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
    if (e.checked) {
      initData.checkCount++;
      initData.deleteName.push($(e).data('dataInfo').Id);
    }
  })
  if (initData.checkCount == len) {
    $('#jv-checkboxAll').prop("checked", true);
  } else {
    $('#jv-checkboxAll').prop("checked", false);
  }
}

function tagOption() {
  _sher.find('#jv-addTag').slideDown();
}

(function() {
  'use strict'

  $(document).ready(function() {
    docker_pulling();

  })
  docker_exim_list($('#jv-mainContent'));
  getExportContainerDir($('#jv-mainContent'));

  let lang = localStorage.getItem('lang');
  changeLanguage(lang);

}())
