function closePopup() {

  $('#jv-popup').fadeOut();
  clearInterval(window.volumeInterval);
  clearInterval(window.containersLognIterval);
  clearInterval(window.containersStatisticsIterval);
  clearInterval(window.containersLognIterval);
  clearInterval(window.containersStatisticsIterval);
  clearTimeout(window.containerTimer);
  clearTimeout(window.containerHomeTimer);
  setTimeout(function() {
    $('#jv-modal-content').empty();
    $('#jv-box-footer').empty();
    $('#jv-popup').removeClass('popupbox-y');
  }, 500)
  document.body.style.overflow = 'auto';
  document.body.style.height = '100%';
}

function closeSecondPopup() {
  clearInterval(window.containersLognIterval);

  $('#jv-secondPopup').fadeOut();
  closeSocket();
  setTimeout(function() {
    $('#jv-modal-content-2').empty();
    $('#jv-box-footer-2').empty();
    $('#jv-secondPopup').removeClass('popupbox-y');
  }, 500)
  document.body.style.overflow = 'auto';
  document.body.style.height = '100%';
}

function wfOnDocumentReady() {
  $('#jvt-templates').hide();
}

function wfTemplateAppend(target, template, name) {
  $('#' + template).clone().attr('id', name).show().appendTo(target);

  var tagName = '#' + name;
  return $(tagName);
}

function arrTrans(num, arr) { // 一维数组转换为二维数组
  const iconsArr = []; // 声明数组
  arr.forEach((item, index) => {
    const page = Math.floor(index / num); // 计算该元素为第几个素组内
    if (!iconsArr[page]) { // 判断是否存在
      iconsArr[page] = [];
    }
    iconsArr[page].push(item);
  });
  return iconsArr;
}

function addVersionNumber(s) {
  for (var i = 0; i < s.length; i++) {
    if (s[i].href) {
      s[i].href = s[i].href + "?v=" + new Date().getTime();
    }
    if (s[i].src) {
      s[i].src = s[i].src + "?v=" + new Date().getTime();
    }
  }
}

function loadCss(cS, p) {
  var m = document.getElementById('jv-mainContent');
  var link = '';
  for (var i = 0; i < cS.length; i++) {
    var cssLink = document.createElement('link');
    cssLink.rel = 'stylesheet';
    cssLink.href = cS[i] + "?v=" + new Date().getTime();
    m.insertBefore(cssLink, m.children[p]);
  }
}
// 时间转换成 yyyy-MM-dd HH:mm:ss
function formatDate(d) {
  var date = new Date(d);
  var YY = date.getFullYear() + '-';
  var MM = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '-';
  var DD = (date.getDate() < 10 ? '0' + (date.getDate()) : date.getDate());
  var hh = (date.getHours() < 10 ? '0' + date.getHours() : date.getHours()) + ':';
  var mm = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes()) + ':';
  var ss = (date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds());
  return YY + MM + DD + " " + hh + mm + ss;
}

// 转换GB
function formSize(bytes, decimalPoint, kbt) {
  var num = bytes;
  if (typeof(num) !== "number") {
    num = parseInt(num);
  }

  if (num <= 0) return '0 B';
  var k = kbt || 1024,
    dm = decimalPoint || 2,
    sizes = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB', 'BB'],
    i = Math.floor(Math.log(num) / Math.log(k));

  return parseFloat((num / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
}

// 开关
function switchControl(t, callback) {
  $(t).toggleClass("open").children(".switch-btn").toggleClass("right");

  let clickType = $(t).hasClass('open') ? true : false;

  if (typeof callback === 'function') {
    callback(clickType);
  }
}
//
function selectOption() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let v = $(t).val();
  $(t).attr('data-value', v);
}

function getClientHeight() {
  var clientHeight = 0;
  if (document.body.clientHeight && document.documentElement.clientHeight) {
    clientHeight = Math.min(document.body.clientHeight, document.documentElement.clientHeight);
  } else {
    clientHeight = Math.max(document.body.clientHeight, document.documentElement.clientHeight);
  }
  return clientHeight;
}

function getClientWH() {
  var clientHeight = 0;
  if (document.body.clientHeight && document.documentElement.clientHeight) {
    clientHeight = Math.min(document.body.clientHeight, document.documentElement.clientHeight);
    clientWidth = Math.min(document.body.clientWidth, document.documentElement.clientWidth);
  } else {
    clientHeight = Math.max(document.body.clientHeight, document.documentElement.clientHeight);
    clientWidth = Math.max(document.body.clientWidth, document.documentElement.clientWidth);
  }

  return {
    w: clientWidth,
    h: clientHeight
  };
}

function jumpPage(url) {
  var href = location.href.substring(0, top.location.href.indexOf('#'));
  location.href = href + '#/' + url;
  $('.navItem').each(function(i, ev) {
    let srcEv = $(ev).find('img').attr('src');
    $(ev).removeClass('currentNav');
    $(ev).find('img').attr('src', srcEv.substring(0, (srcEv.length - 5)) + 'n.png');
    if ($(ev).find('a').attr('href') == location.hash) {
      $(ev).addClass('currentNav')
      $(ev).find('img').attr('src', srcEv.substring(0, (srcEv.length - 5)) + 'y.png');
      $('#jv-headerTitle').text($(ev).text());
    }
  })
}
//下载文件
function downloadFile(url, type) {
  $('#jv-docker_loading').show();
  var request = new XMLHttpRequest();
  request.responseType = "blob";
  let fileUrl = url; // 文件路径
  request.open("GET", fileUrl);
  request.onload = function() {
    var url = window.URL.createObjectURL(this.response);
    var $a = document.createElement('a');
    $a.setAttribute("href", url);
    $a.setAttribute("download", type);
    var evObj = document.createEvent('MouseEvents');
    evObj.initMouseEvent('click', true, true, window, 0, 0, 0, 0, 0, false, false, true, false, 0, null);
    $a.dispatchEvent(evObj);
    $('#jv-docker_loading').hide();
  }
  request.send();
}

//提示弹窗
function errorMessageBox(msg, lan) {
  if (!msg) {
    return;
  }

  $('#jv-messageBox').remove();
  var divF = "<div id='jv-messageBox'></div>";
  $('body').append(divF);
  $('#jv-messageBox').empty();
  var div = "<div class='tip'><span data-lang=" +  JSON.stringify(lan) + "></span></div>";
  $('#jv-messageBox').append(div);

  $(".tip").css('left', '0');
  $('.tip').fadeIn(1000);
  $(".tip span").html(msg);
  var h = +$(".tip span").height();
  $(".tip").css('top', (getClientHeight() / 2 - h)+ "px");
  setTimeout(function() {
    $('#jv-messageBox').fadeOut();
  }, 3000);
  changeLanguage(localStorage.getItem('lang'));
}

//  调用弹窗
// obj 传递的参数
// callback 回调
function showModel(obj = {}, callback, classname) {
  $('#jv-modal-content').empty();
  $('#jv-box-footer').empty();
  let popup = wfTemplateAppend('#jv-modal-content', obj.oemplateName, obj.id);
  let footerBtn = wfTemplateAppend('#jv-box-footer', 'jvt-footer-btn', 'jv-footer-btn').show();

  $('#jv-popup').fadeIn().attr('class', 'box');

  $('#jv-popup').fadeIn().addClass(classname || '');

  // 判断是否显示应用按钮
  if (typeof obj.isShowApplicationBtn === 'boolean') {
    if (!obj.isShowApplicationBtn) {
      $('#jv-popup').find('.applicationBtn').hide();
    } else {
      $('#jv-popup').find('.applicationBtn').show();
    }
  }
  // 判断是否显示所有按钮
  if (obj.isShowFooterBtn) {
    $('#jv-box-footer').show();
  } else {
    $('#jv-box-footer').hide();
  }

  if (obj.confirmBtn || obj.confirmBtn == undefined) {
    $('#jv-popup').find('.subBtn').show();
  } else {
    $('#jv-popup').find('.subBtn').hide();
  }

  if (obj.closeBtn || obj.closeBtn == undefined) {
    $('#jv-popup').find('.cancelBtn ').show();
  } else {
    $('#jv-popup').find('.cancelBtn ').hide();
  }

  // 修改按钮文字
  if (obj.btnText2) {
    $('#jv-popup').find('.subBtn').text(obj.btnText2).attr('data-lang', obj.btnLang ? obj.btnLang : 'Confirm');
    $('#jv-popup').find('.subBtn').text($('#jv-popup').find('.subBtn').text());
  } else {
    $('#jv-popup').find('.subBtn').text($('#jv-popup').find('.subBtn').text());
  }

  if (obj.btnStlye) {
    $('#jv-popup').find('.subBtn').css({
      'background': obj.btnStlye.background,
      'border': obj.btnStlye.border
    });
  }

  $('#jv-modal-title').html(obj.title);

  // 点击事件
  $('#jv-popup .jvc-btn').click(function(e) {
    // 判断是否需要回调，需要返回点击状态
    let clickType = $(this).attr('name') == 'submit' ? true : $(this).attr('name') == 'app' ? true : false;

    if (typeof callback === 'function') {
      callback(clickType);
    }

    if ($(this).attr('name') == 'close') {
      closePopup();
    }

  })
  changeLanguage(localStorage.getItem('lang'));

  document.body.style.overflow = 'hidden';
  document.body.style.height = document.documentElement.clientHeight;

  return popup;
}
//  第二层调用弹窗
function showSecondModel(obj = {}, callback, classname) {

  $('#jv-modal-content-2').empty();
  $('#jv-box-footer-2').empty();
  $('#jv-secondPopup').fadeIn().addClass(classname || '');
  let popup = wfTemplateAppend('#jv-modal-content-2', obj.oemplateName, obj.id);
  let footerBtn2 = wfTemplateAppend('#jv-box-footer-2', 'jvt-footer-btn', 'jv-footer-btn2').show();



  // 判断是否显示应用按钮
  if (typeof obj.isShowApplicationBtn === 'boolean') {
    if (!obj.isShowApplicationBtn) {
      $('#jv-secondPopup').find('.applicationBtn').hide();
    } else {
      $('#jv-secondPopup').find('.applicationBtn').show();
    }
  }
  // 判断是否显示所有按钮
  if (obj.isShowFooterBtn) {
    $('#jv-box-footer-2').show();
  } else {
    $('#jv-box-footer-2').hide();
  }

  $('#jv-modal-title-2').html(obj.title);

  // 点击事件
  $('#jv-secondPopup .jvc-btn').click(function() {
    // 判断是否需要回调，需要返回点击状态
    let clickType = $(this).attr('name') == 'submit' ? true : $(this).attr('name') == 'app' ? true : false;

    if (typeof callback === 'function') {
      callback(clickType);
    }

    if ($(this).attr('name') == 'close') {

    }

    closeSecondPopup();
  })

  changeLanguage(localStorage.getItem('lang'));

  document.body.style.overflow = 'hidden';
  document.body.style.height = document.documentElement.clientHeight;
  return popup;
}

function getCookie(name) {
  var arr, reg = new RegExp("(^| )" + name + "=([^;]*)(;|$)");
  if (arr = document.cookie.match(reg))
    return unescape(arr[2]);
  else
    return null;
}

function showPageList() {
  var ev = window.event || arguments.callee.caller.arguments[0];
  ev.stopPropagation();
  var node = $(ev.currentTarget).parent('.pageitemcon');
  node.find('.pageList').slideToggle();

  document.onclick = function(e) {
    e.stopPropagation();
    $('.pageList').slideUp();
  }
}


function loadCSS(cssFile, callback) {
  if (typeof cssFile === 'undefined' || typeof document.getElementsByTagName("head")[0] === 'undefined') {
    return false;
  }
  cssFile = cssFile + '?v=' + new Date().getTime();

  var fileref = document.createElement("link");
  fileref.setAttribute("rel", "stylesheet");
  fileref.setAttribute("type", "text/css");
  fileref.setAttribute("href", cssFile);
  if (fileref.readyState) {
    fileref.onreadystatechange = function() {
      if (fileref.readyState == "loaded" || fileref.readyState == "complete") {
        fileref.onreadystatechange = null;
        if (callback && typeof callback === "function") {
          callback();
        }
      }
    };
  } else {
    fileref.onload = function() {
      if (callback && typeof callback === "function") {
        callback();
      }
    };
  }
  if (typeof fileref != "undefined")
    $("#jv-mainContent").find('script')[0].before(fileref);
  return fileref; //return the element.
}

function LoadJS(jsFile, callback, async) {
  if (typeof async ==='undefined') async = true; //default is true.
  if (typeof jsFile === 'undefined') {
    return false;
  }
  var script = document.createElement('script');
  script.type = 'text/javascript';
  script.async = async;
  if (script.readyState) {
    script.onreadystatechange = function() {
      if (script.readyState == "loaded" || script.readyState == "complete") {
        script.onreadystatechange = null;
        if (callback && typeof callback === "function") {
          callback();
        }
      }
    };
  } else {
    script.onload = function() {
      if (callback && typeof callback === "function") {
        callback();
      }
    };
  }
  script.src = jsFile + "?v=" + VERSION_ATIME;
  (document.getElementsByTagName('head')[0] || document.getElementsByTagName('body')[0]).appendChild(script);
}

function registryDefault(that, id, fun) {
  var data = {
    cmd : 'docker_registry_default',
    "token": getCookie('PHPSESSID') || "",
    "params": {
    	"id": +id
    }
  }
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(res) {
      if (res.err == 0) {
        if (fun && typeof fun === "function") {
          fun();
        }
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

(function() {
  'use strict'

}())
