SPA_RESOLVE_INIT = function(transition) {}

SPA_RESOLVE_HTML = function(transition) {}
var that_ConsoleDesk = null;
var that_linkConsoleDesk = null;
var that_linkContainer = null;
var cmdtype = false;

// 执行控制台
function implementConsoleDesk() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let target = event.target;
  targetContainerInfo = $(target).data('dataInfo') || containerDetailsInfo;
  that_ConsoleDesk = showModel({
    title: '<span data-lang="containerConsole">执行控制台</span>',
    oemplateName: 'jvt-implementConsoleDesk',
    id: 'jv-implementConsoleDesk',
    isShowApplicationBtn: false,
    isShowFooterBtn: true,
    btnText2: '连接'

  }, function(e) {
    if (e) {

      linkConsoleDesk();
    }

  })

}

function linkConsoleDesk() {
  that_linkConsoleDesk = showSecondModel({
    title: '<span data-lang="containerConsole">执行控制台</span>',
    oemplateName: 'jvt-consoleDesk',
    id: 'jv-consoleDesk',
    isShowApplicationBtn: false,
    isShowFooterBtn: false,

  }, function(e) {

  })

  let cmd = [],
    user = that_ConsoleDesk.find('#jv-root').val();

  if (cmdtype) {
    let str = that_ConsoleDesk.find('#jv-zdyml').val();
    if (str) {
      cmd = splitargs(str);
    }

  } else {
    cmd.push(that_ConsoleDesk.find('.selectControl').attr('data-value'));
  }

  var data = {
    "id": targetContainerInfo.Id,
    "AttachStdin": true,
    "AttachStdout": true,
    "AttachStderr": true,
    "Tty": true,
    "Cmd": cmd
  };

  if (user) {
    data['User'] = user;
  }

  var obj = {
    url: "../api/endpoints/" + globalData.tty + "/docker/containers/" + targetContainerInfo.Id + "/exec",
    data: JSON.stringify(data)
  };

  var fn = {
    success: terminalSocket
  };
  postData(obj, fn);
}

function useCustomCommand(t) {
  switchControl(t);

  if ($(t).hasClass('open')) {
    that_ConsoleDesk.find('#jv-zdyml').show().siblings('.selectControl').hide();
    cmdtype = true;
  } else {
    that_ConsoleDesk.find('.selectControl').show().siblings('#jv-zdyml').hide();
    cmdtype = false;
  }

}

function linkContainer() {

  that_linkContainer = showSecondModel({
    title: '<span data-lang="containerConsole">执行控制台</span>',
    oemplateName: 'jvt-linkContainerM',
    id: 'jv-linkContainerM',
    isShowApplicationBtn: false,
    isShowFooterBtn: false,

  }, function(e) {

  })

  if (containerDetailsInfo.Config.OpenStdin) {
    that_linkContainer.find('.jvc-i').hide();
  } else {
    that_linkContainer.find('.jvc-i').show();
  }

  if (containerDetailsInfo.Config.Tty) {
    that_linkContainer.find('.jvc-t').hide();
  } else {
    that_linkContainer.find('.jvc-t').show();
  }

  linkContainerSocket();

}


function linkContainerSocket() {
  let host = window.location.host;
  var s = window.location.pathname;
  var i = s.lastIndexOf("/")
  var str = s.substr(0, s.lastIndexOf("/", i - 1))

  if (window.location.protocol == "https:") {
    socket = new WebSocket('wss://' + host + str + '/api/endpoints/1/websocket/containers/' + containerDetailsInfo.Id + '/attach/ws?logs=0&stream=1&stdin=1&stdout=1&stderr=1');
  } else {
    socket = new WebSocket('ws://' + host + str + '/api/endpoints/1/websocket/containers/' + containerDetailsInfo.Id + '/attach/ws?logs=0&stream=1&stdin=1&stdout=1&stderr=1');
  }

  const attachAddon = new AttachAddon.AttachAddon(socket);
  term.open(that_linkContainer.find('#jv-terminal')[0]);
  const fitAddon = new FitAddon.FitAddon();
  term.loadAddon(fitAddon);

  socket.onopen = function(connection) {
    term.loadAddon(attachAddon);
  };

  socket.onmessage = function(message) {
    term.write(message);
  };
}

function getImagesList(taht) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/images/json?all=0',
    type: "get",
  }
  postData(obj, {
    success: function(result) {
      $('#jv-imagesListHost').empty();
      if (result) {
        for (var i = 0; i < result.length; i++) {
          let info = result[i];
          let imagesDom = wfTemplateAppend($('#jv-imagesListHost'), 'jvt-imagesItem', 'jvt-imagesItem' + i);
          imagesDom.html(info.RepoTags);
        }
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  })
}

function imagesInputοnblur() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  $(t).parent().find('#jv-imagesListHost').slideUp();
}

function imagesInputonfocus() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  $(t).parent().find('#jv-imagesListHost').slideDown();
}

function selectImages() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  var v = $(t).text();
  $(t).parent().parent().find("input[name='registriesName']").val(v);
}
// 导入容器文件
function importFile() {
  var file_content = "";
  var that_import_file = showModel({
    title: '<span data-lang="import">导入</span>',
    oemplateName: 'jvt-importFile',
    id: 'jv-importFile',
    isShowApplicationBtn: false,
    isShowFooterBtn: true,
    btnText2: '导入',
    btnLang: 'import',
    btnStlye: {
      background: '#FF7978',
      border: '1px solid #FF7978'
    }

  }, function(e) {
    if (e) {
      var dir = that_import_file.find('.listInfoItemVal').val();
      var lt = dir.split('/');
      var filename = lt[lt.length - 1];
      var fileType = filename.split(".").slice(-1);

      if (!file_content) {
        errorMessageBox('请选择要导入的文件！');
        return;
      }

      if (fileType == 'json') {
        initData.is_import = true;
        initData.is_openimage = false;
        modifyContainer(unas_json);
      } else {
        docker_container_create(file_content, 'yaml', true, false, dir);
      }

      // var dir = that_import_file.find('.listInfoItemVal').val();
      // var lt = dir.split('/');
      // var filename = lt[lt.length - 1];
      // var ishf = 1;
      // if (!dir) {
      //   errorMessageBox('请选择要导入的文件！');
      //   return;
      // }
      //
      // for (var i = 0; i < fileListType.length; i++) {
      //   if (filename == fileListType[i]) {
      //     ishf = 0;
      //   }
      // }
      // if (ishf) {
      //   // errorMessageBox('文件不合法！');
      //   // return;
      // }
      // var fileType = filename.split(".").slice(-1);
      // if (fileType == 'json') {
      //   initData.is_import = true;
      //   initData.is_openimage = false;
      //   modifyContainer(unas_json);
      //   closePopup();
      // }else if (fileType == 'yml' || fileType == 'yaml'){
      //   var that_dockerImport = showModel({
      //     title: '<span data-lang="container">容器</span>',
      //     oemplateName: 'jvt-dockerImport',
      //     id: 'jv-dockerImport',
      //     isShowApplicationBtn: false,
      //     isShowFooterBtn: true,
      //
      //   }, function(e) {
      //     if (e) {
      //       let containerName = that_dockerImport.find('input').val().toLowerCase();
      //       if (!containerName) {
      //         errorMessageBox('容器名称不能为空！');
      //         return;
      //       }
      //       if (!(/^[a-zA-Z0-9_.-]+$/.test(containerName))) {
      //         errorMessageBox('容器名称不合法！');
      //         return;
      //       }
      //       docker_import(dir, containerName);
      //       closePopup();
      //
      //     }
      //
      //   })
      //   that_dockerImport.find('.jvc-imagesName').attr('data-lang',"containerName");
      //   changeLanguage(localStorage.getItem('lang'));
      // }else {
      //   var that_dockerImport = showModel({
      //     title: '<span data-lang="images">镜像</span>',
      //     oemplateName: 'jvt-dockerImport',
      //     id: 'jv-dockerImport',
      //     isShowApplicationBtn: false,
      //     isShowFooterBtn: true,
      //
      //   }, function(e) {
      //     if (e) {
      //       let imageName = that_dockerImport.find('input').val().toLowerCase();
      //       if (!imageName) {
      //         errorMessageBox('镜像名称不能为空！');
      //         return;
      //       }
      //       if (!(/^[a-z0-9-._/]+(:[a-z0-9-._]+)?$/.test(imageName))) {
      //         errorMessageBox('镜像名称不合法！');
      //         return;
      //       }
      //       docker_import(dir, imageName);
      //       closePopup();
      //
      //     }
      //
      //   })
      // }

    }
  }, 'popupbox-y')
  jQuery('#jv-backup-setting').attr('onclick', '');
  that_import_file.parent('.modal-content').css('overflow', 'inherit');
  $('#jv-file').unbind();
  $('#jv-file').on('click');

  that_import_file.find('#jv-localUpload').off('click').on('click', function() {
    selectContainerFile(that_import_file);
  });

  that_import_file.parent().parent().find('.subBtn').addClass('disabledbtn');

  that_import_file.find('.listInfoItemVal').on('change', function() {
    var v = $(this).val();
    that_import_file.parent().parent().find('.subBtn').removeClass('disabledbtn');
    that_import_file.find('#jv-localUpload').removeClass('disabledbtn');
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_yml",
      "params": {
        "file": v
      }
    }

    $.ajax({
      url: '../../unas-docker/includes/index.php', //接口
      type: "post", //GET或POST
      data: JSON.stringify(data), //数据
      dataType: 'json',
      contentType: 'application/json',
      success: function(res) {
        var info = res.results || {};
        if (res.err == 0) {
          file_content = info.content;
        } else {
          file_content = '';
        }

      }, //回调成功方法
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });

  });

  dir_file = 'import';
}

// 上传容器文件
function selectContainerFile(t) {
  var file = null;
  var dir = t.find('.listInfoItemVal').val();
  var filedir = t.find('.listInfoItemVal').val();
  $('#jv-file').change(function(e) {
    file = e.target.files[0];
    var fileString = {};
    fileType = $("#jv-file").val().split(".").slice(-1)[0];
    if (fileType == 'json') {
      var reader = new FileReader(); //新建一个FileReader
      reader.readAsText(file, "UTF-8"); //读取文件
      reader.onload = function(evt) { //读取完文件之后会回来这里
        fileString = evt.target.result; // 读取文件内容
        initData.is_import = true;
        initData.is_openimage = false;
        modifyContainer(JSON.parse(fileString));
        e.target.value = '';
        closePopup();
      }
    }else if (fileType == 'yaml' || fileType == 'yml') {

      docker_container_create(fileString, 'yaml', true, false, dir);

    } else {
      showLoading();
      var form = document.getElementById("jv-holder");
      var formdata = new FormData(form);
      formdata.append("file", file);
      formdata.append("fileName", file.name);
      $.ajax({
        url: '../../unas-docker/includes/upload.php', //接口
        type: "post", //GET或POST
        data: formdata, //数据
        processData: false, // 不处理发送的数据，因为data值是Formdata对象，不需要对数据做处理
        contentType: false, // 不设置Content-type请求头
        success: function(result) {
          var filename = result;
          var fileType = filename.split(".").slice(-1)[0];
          hideLoading();
          jQuery('jv-holder').remove();
          if (fileType == "json") {
            var that_dockerImport = showModel({
              title: '<span data-lang="images">镜像</span>',
              oemplateName: 'jvt-dockerImport',
              id: 'jv-dockerImport',
              isShowApplicationBtn: false,
              isShowFooterBtn: true,

            }, function(e) {
              if (e) {
                let imageName = that_dockerImport.find('input').val().toLowerCase();
                if (!imageName) {
                  errorMessageBox('镜像名称不能为空！');
                  return;
                }
                if (!(/^[a-z0-9-._/]+(:[a-z0-9-._]+)?$/.test(imageName))) {
                  errorMessageBox('镜像名称不合法！');
                  return;
                }
                docker_import(filename, imageName);
                closePopup();

              }

            });
          } else if (fileType == 'unas_tgz') {
            var that_dockerImport = showModel({
              title: '<span data-lang="container">容器</span>',
              oemplateName: 'jvt-dockerImport',
              id: 'jv-dockerImport',
              isShowApplicationBtn: false,
              isShowFooterBtn: true,

            }, function(e) {
              if (e) {
                let containerName = that_dockerImport.find('input').val().toLowerCase();
                if (!containerName) {
                  errorMessageBox('镜像名称不能为空！');
                  return;
                }
                if (!(/^[a-z0-9-._/]+(:[a-z0-9-._]+)?$/.test(containerName))) {
                  errorMessageBox('镜像名称不合法！');
                  return;
                }
                is_tar = 1;
                docker_import(filename, containerName);
                closePopup();

              }

            });
            that_dockerImport.find('.jvc-imagesName').attr('data-lang', "imagesName");
            changeLanguage(localStorage.getItem('lang'));
          }
          e.target.value = '';
        }, //回调成功方法
        error: function(xhr, textStatus) {
          console.log(xhr);
          console.log(textStatus);
        }
      });
    }

  });

  $('#jv-file').click();
}

function docker_import(filename, tag) {
  return new Promise(function(resolve, reject) {
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_import",
      "params": {
        "file": filename,
        "tag": tag
      }
    };
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }

    postData(obj, {
      success: function(result) {
        initData.is_import = true;
        resolve(result);
        result.results = result.results || {};
        if (result && result.results.conf) {
          initData.is_openimage = true;
          modifyContainer(result.results.conf);
        }

      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })

}

function exportContainerS() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  event.stopPropagation();
  let tar = false;
  let profile = false;
  let yml = false;

  $(t).siblings('.exportTypeList').slideToggle().find('li').off().on('click', function(e) {
    e.stopPropagation();
    let exportType = $(e.target).text();
    $(e.target).parent().slideUp();
    if (exportType == 'tar') {
      tar = true;
      profile = true;
    } else if (exportType == 'json') {
      profile = true;
    } else {
      yml = true;
    }

    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_export",
      "params": {
        "profile": profile,
        "tar": tar,
        "yml": yml
      }
    };

    if (!jQuery('#jv-d-tbodybox input[type=checkbox]:checked').length) {
      return;
    }
    docker_export(data);

  })

}

function docker_export(data) {

  var thatExportContainer = showModel({
    title: '<span data-lang="export">导出</span>',
    oemplateName: 'jvt-exportContainer',
    id: 'jv-exportContainer',
    isShowApplicationBtn: false,
    isShowFooterBtn: true,
    btnText2: '导出',
    btnLang: 'export',
    btnStlye: {
      background: '#FF7978',
      border: '1px solid #FF7978'
    }

  }, function(e) {
    if (e) {
      var dir = thatExportContainer.find('.listInfoItemVal').val();
      if (!dir) {
        errorMessageBox('请选择要导出的文件位置！');
        return;
      }

      data.params['target_dir'] = dir;

      jQuery('#jv-d-tbodybox input[type=checkbox]:checked').each(function(i, e) {
        var dataInfo = jQuery(e).data('dataInfo');
        let containerNames = dataInfo.Names.toString();
        if (containerNames[0] == '/') {
          containerNames = containerNames.substr(1);
        }
        data.params['container'] = containerNames;
        selectExportContainerPos(data, false);
      })
    }
  }, 'popupbox-y')

  thatExportContainer.parent('.modal-content').css('overflow', 'inherit');
  thatExportContainer.find('.jvc-localUpload').on('click', function() {
    jQuery('#jv-d-tbodybox input[type=checkbox]:checked').each(function(i, e) {
      var dataInfo = jQuery(e).data('dataInfo');
      let containerNames = dataInfo.Names.toString();
      if (containerNames[0] == '/') {
        containerNames = containerNames.substr(1);
      }
      data.params['container'] = containerNames;
      selectExportContainerPos(data, true);
    })
  });
  dir_file = 'export';

}
//导出容器
function exportContainer() {
  return new Promise(function(resolve, reject) {
    let event = window.event || arguments.callee.caller.arguments[0];
    event.stopPropagation();
    let t = event.target;
    let info = JSON.parse($(t).data('dataInfo'));
    let tar = false;
    let profile = false;
    let yml = false;
    $('.jvc-moreOPbox').hide();
    $(t).closest('div.dr-item').siblings().find('.jvc-selectexportType').slideUp();
    $(t).siblings('.jvc-selectexportType').slideToggle().find('li').off().on('click', function(e) {
      e.stopPropagation();
      let exportType = $(e.target).text();
      $(e.target).parent().parent().slideUp();
      if (exportType == 'tar') {
        tar = true;
        profile = true;
      } else if (exportType == 'json') {
        profile = true;
      } else {
        yml = true;
      }

      let containerNames = info.Names.toString();
      if (containerNames[0] == '/') {
        containerNames = containerNames.substr(1);
      }

      let data = {
        "token": getCookie('PHPSESSID') || "",
        "cmd": "docker_export",
        "params": {
          "container": containerNames,
          "profile": profile,
          "tar": tar,
          "yml": yml
        }
      };

      var thatExportContainer = showModel({
        title: '<span data-lang="export">导出</span>',
        oemplateName: 'jvt-exportContainer',
        id: 'jv-exportContainer',
        isShowApplicationBtn: false,
        isShowFooterBtn: true,
        btnText2: '导出',
        btnLang: 'export',
        btnStlye: {
          background: '#FF7978',
          border: '1px solid #FF7978'
        }

      }, function(e) {
        if (e) {
          var dir = thatExportContainer.find('.listInfoItemVal').val();
          if (!dir) {
            errorMessageBox('请选择要导出的文件位置！');
            return;
          }

          data.params['target_dir'] = dir;
          selectExportContainerPos(data, false);
        }
      }, 'popupbox-y');
      thatExportContainer.parent('.modal-content').css('overflow', 'inherit');
      thatExportContainer.find('.jvc-localUpload').on('click', function() {
        selectExportContainerPos(data, true);
      });
      dir_file = 'export';
    })

  })

}
//选择容器导出位置

function selectExportContainerPos(data, t) {
  showLoading();
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(result) {
      if (result.err == 0) {
        let info = result.results || {};
        if (info.link && t) {
          downloadFile(info.link, info.name);
        }
        hideLoading();
        closePopup();
      } else {
        if (result.message) {
          errorMessageBox(result.message);
        }
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  }, false);
}

// 升/降序函数
function containerSort(_t, _ss, data) {
  if (data._ss != '' && isNaN(data._ss)) {
    if (_t == "ascending") { //升序
      data.sort(function(a, b) {
        var val1 = a[_ss];
        var val2 = b[_ss];
        //升序
        if (val1 < val2) {
          return -1;
        } else if (val1 > val2) {
          return 1;
        } else {
          return 0;
        }
      });
    } else if (_t == "descending") {
      data.sort(function(a, b) { //降序
        var val1 = a[_ss];
        var val2 = b[_ss];
        //降序
        if (val2 < val1) {
          return -1;
        } else if (val2 > val1) {
          return 1;
        } else {
          return 0;
        }
      });
    }
  }
  return data;
}

function docker_container_creating() {
  initData.pullingList = [];
  return new Promise(function(resolve, reject) {
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_container_creating"
    };
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }

    postData(obj, {
      success: function(res) {
        resolve(res);
        initData.pullingList = res.results.creating || [];
        first_ && (initData.createing_container = res.results.creating || []);
        createing_jobid = [];
        $('#jv-d-tbodybox-createing').empty();
        for (var k = 0; k < initData.createing_container.length; k++) {
          var cj_job = initData.createing_container[k]['JOB_ID'];
          createing_jobid.push(cj_job);
        }

        if (initData.pullingList.length) {
          for (var i = 0; i < initData.pullingList.length; i++) {
            var tl = initData.pullingList[i];
            var container = tl['CONTAINER'] || [];
            var image = tl['IMAGE'] || [];
            var n_h = '',
              i_h = '';
            var creatingDom = wfTemplateAppend('#jv-d-tbodybox-createing', 'jvt-creating-tr', 'jvt-creating-tr' + i);

            creatingDom.find('.jvc-stopcreat').attr('jobid', tl['JOB_ID']).on('click', function() {
              var jobid = $(this).attr('jobid');
              docker_container_stop(jobid);
            });

            for (var j = 0; j < container.length; j++) {
              n_h += '<span class="ncmitem">' + container[j] + '</span>'
            }
            creatingDom.find('.jvc-name').html(n_h);
            for (var j = 0; j < image.length; j++) {
              i_h += '<span class="imcitem">' + image[j] + '</span>'
            }
            creatingDom.find('.jvc-image').html(i_h);
          }

          creatingTime = setTimeout(function() {
            docker_container_creating();
          }, 3000);

          if (initData.pullingList.length != initData.createing_container.length) {
            getData();
            initData.createing_container = res.results.creating || []
          }

          first_ = 0;
          $('#jv-volumeNull').hide();
        } else {
          getData();
          clearInterval(creatingTime);
          first_ = 1;
          initData.createing_container = [];
        }
         if (res.results.lasterror) {
           var msg = res.results.lasterror.message.replaceAll('\n', '<br/>');
            errorMessageBox(msg);
         }
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })

}

function docker_container_stop(id) {
  clearInterval(creatingTime);
  return new Promise(function(resolve, reject) {
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_container_stop",
      "params": {
        "job_id": id
      }
    };
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }

    postData(obj, {
      success: function(res) {
        docker_container_creating();
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })

}

function showSortModle() {
  let event = window.event || arguments.callee.caller.arguments[0];
  event.stopPropagation();
  $('#jv-sortList').slideToggle();
  $('#jv-sortModleList li').each(function(i, e) {
    e.onclick = function(e) {
      e.stopPropagation();
      $(e.target).addClass('actived').siblings().removeClass('actived');
      var _t = $('#jv-sortTypeList li').siblings(".actived")[0].type;
      var _ss = $(e.target).siblings().siblings(".actived")[0].type;
      refreshInfo(containerSort(_t, _ss, initData.list), initData.count, initData.curr);
    }
  })

  $('#jv-sortTypeList li').each(function(i, e) {
    e.onclick = function(e) {
      e.stopPropagation();
      $(e.target).addClass('actived').siblings().removeClass('actived');
      var _t = $(e.target).siblings().siblings(".actived")[0].type;
      var _ss = $('#jv-sortModleList li').siblings(".actived")[0].type;
      refreshInfo(containerSort(_t, _ss, initData.list), initData.count, initData.curr);
    }
  })

  $(document).on('click', function(e) {
    e.stopPropagation();
    $('#jv-sortList').slideUp();
  })
}

function switchOp() {
  $('#jv-deleteBtnList').slideToggle();
  event.stopPropagation();
  $(document).on('click', function(e) {
    e.stopPropagation();
    $('#jv-deleteBtnList').slideUp();
  })
}

function createCompose() {
  $('#desktopHiddenModal').remove();
  var m = '<div id="desktopHiddenModal" class="hiddenModal"></div>';
  $('body').append(m);
  var Composewin = new WinBox("Compose", {
    id: 'jv-composewin',
    x: "center",
    y: "center",
    width: "100%",
    height: "100%",
    onclose: function() {
      closewin();
    },
    mount: jQuery('<div class="win-container"></div>').load('./m/module/container/compose.html')[0]
  });
  dir_file = 'compose';
}

function closewin(t) {
  $('#desktopHiddenModal').remove();
  t && t.remove();
}

(function() {
  'use strict'

  $('body').on('click', '.modifyContainerNavItem', function(e) {
    let t = $(e.currentTarget);
    let i = $(e.currentTarget).index();
    t.addClass('currentotherSettingsNavItem').siblings().removeClass('currentotherSettingsNavItem');
    $('#jv-secondPopup .modifyContainerItem').eq(i).show().siblings().hide();
  })

  $(document).ready(function() {
    $('#jv-subsidiaryDepartment').empty();
    $('#jv-subsidiaryDepartmentFile').empty();
    $('#jv-dirpos').empty();
    getCrporateCorporat($('#jv-mainContent'));
    docker_exim_list($('#jv-mainContent'));
    getExportContainerDir($('#jv-mainContent'));
    getData();
    getImagesList();
    docker_container_creating();
    let lang = localStorage.getItem('lang');
    changeLanguage(lang);
  })

  document.onclick = function(e) {
    e.stopPropagation();
    jQuery('.exportTypeList').slideUp();
    jQuery('.jvc-moreOPbox').hide();
    jQuery('.jvc-selectexportType').hide();
  }

}())
