var that_createContainer = null;
var imageNameInfo = null; //镜像信息
var targetInput = null;
var is_create = 1;
var initCreateContainerData = {
  isAutoPull: false,
  fromImage: ''
}
var filedir = '',
  is_tar = 0;
  
// 创建容器弹窗模块
function createContainer(t) {

  that_createContainer = showModel({
    title: '<span data-lang="addContainer">创建容器</span>',
    oemplateName: 'jvt-createContainer',
    id: 'jv-createContainer',
    isShowApplicationBtn: false,
    isShowFooterBtn: true

  }, function(e) {
    if (e) {

      confirmCreateContainer(that_createContainer);
    }
  })

  that_createContainer.find('.jvc-consoleList img').click(function(e) {
    $(this).attr('src', './image/radio_selected.png').parent().siblings().find('img').attr('src', './image/radio.png');
  });

  that_createContainer.find('#jv-restartPolicy img').click(function(e) {
    $(this).attr('src', './image/radio_selected.png').parent().siblings().find('img').attr('src', './image/radio.png');
  });

  $('body').on('click', '.containerSetNavItem', function(e) {
    let t = $(e.currentTarget);
    let i = $(e.currentTarget).index();
    t.addClass('currentcontainerSetNavItem').siblings().removeClass('currentcontainerSetNavItem');
    that_createContainer.find('.settingItem').eq(i).show().siblings().hide();

  })

  $('body').on('click', '.otherSettingsNavItem', function(e) {
    let t = $(e.currentTarget);
    let i = $(e.currentTarget).index();
    t.addClass('currentotherSettingsNavItem').siblings().removeClass('currentotherSettingsNavItem');
    that_createContainer.find('.otherSettingsContentItem').eq(i).show().siblings().hide();
  })

  getInfo(that_createContainer);
  getRegistries(that_createContainer, '#jv-generalSettings');
  getVolume();
  getNetworkOption(that_createContainer);
  getNetworkContainersList(that_createContainer);
  setCapabilitiesBtn(that_createContainer);

  // $('#jv-subsidiaryDepartment').empty();
  // getCrporateCorporat(that_createContainer);

}

//提交创建容器数据
function confirmCreateContainer(that, fn, fial) {
  let containerName = that.find("input[name='containerName']").val();
  if (!containerName) {
    errorMessageBox('请题写容器名称');
    return;
  }
  // if (!that.find("input[name='registriesName']").val()) {
  //   errorMessageBox('请题写镜像名称');
  //   return;
  // }


  let autoRemove = that.find("#jv-autoRemove").hasClass('open'); //自动删除
  let publishAllPorts = that.find("#jv-publishAllPorts").hasClass('open'); //同步主机开放端口
  let networkPortPublishingList = that.find('#jv-sdwldkHost').children();
  let networkPortPublishingData = manualNetworkPortPublishing(networkPortPublishingList); //手动网络端口发布

  var fromContainerData = {
    Image: that.find("input[name='registriesName']").val(),
    Env: [],
    ExposedPorts: networkPortPublishingData.exposedPorts,
    HostConfig: {
      AutoRemove: autoRemove, //自动删除
      Binds: [],
      Devices: [],
      Dns: [],
      PublishAllPorts: publishAllPorts, //同步主机开放端口
      PortBindings: networkPortPublishingData.portBindings,
      ExtraHosts: [],
      RestartPolicy: {
        Name: "no"
      },
      Init: false,
      Privileged: false,
      Runtime: null,
    },
    NetworkingConfig: {
      EndpointsConfig: {}
    },
    Labels: {},
    Volumes: {},
    name: containerName,
    OpenStdin: false,
    Tty: false,
  }
  setCommandLogging(that, fromContainerData);
  setVolumeBindData(that, fromContainerData);
  setNetworkData(that, fromContainerData);
  setEnvironmentVariablesData(that, fromContainerData);
  setLabelsData(that, fromContainerData);
  setRestartPolicyData(that, fromContainerData);
  setRuntimeResourcesData(that, fromContainerData);
  setCapabilitiesData(that, fromContainerData);

  // let obj = {
  //   url: '../api/endpoints/' + globalData.tty + '/docker/containers/create?name=' + containerName,
  //   data: JSON.stringify(fromContainerData)
  // }
  var start = that.find("#jv-startImmediately").hasClass('open');
  if (is_tar) {
    initCreateContainerData.isAutoPull = false;
  }
  docker_container_create(fromContainerData, 'json', start, initCreateContainerData.isAutoPull, filedir);


}

function docker_container_create(f, t, s, p, file) {
  if (typeof f != 'string') {
    f = JSON.stringify(f);
  }
  return new Promise(function(resolve, reject) {
    let data = {
      "cmd": "docker_container_create",
      "token": getCookie('PHPSESSID') || "",
      "params": {
        "type": t,
        "data": f,
        "file": file,
        "start": s,
        "force_pull": p
      }
    }
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }

    postData(obj, {
      success: function(result) {
        resolve(result);
        if (result.err != 0) {
          errorMessageBox(result.errmsg);
        } else {
          first_ = 1;
          is_create && docker_container_creating().then(function(res) {});
          closePopup();
          closeSecondPopup();
        }
        filedir = '';
        is_tar = 0;
      },
      complete: function(x) {
        resolve(x);
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
        if (typeof fial === 'function') {
          fial();
        }
        reject(result);
      }
    });
  })

}

//设置手动网络端口发布
function manualNetworkPortPublishing(ports) {
  let networkPortPublishing = {
    exposedPorts: {},
    portBindings: {}
  }
  if (ports.length) {
    ports.each(function(i, e) {
      let key = $(e).find("input[name='contalner']").val() + '/' + $(e).find(".selectControlTcpUdp").attr('data-value');
      let val = $(e).find("input[name='host']").val();
      networkPortPublishing.exposedPorts[key] = {};
      networkPortPublishing.portBindings[key] = [{
        'HostPort': val
      }]

    })
  }
  return networkPortPublishing;
}

//设置命令和日志记录数据
function setCommandLogging(that, obj) {
  let cmd = that.find("input[name='cmd']").val();
  let entrypoint = that.find("input[name='entrypoint']").val();
  let workingDir = that.find("input[name='workingDir']").val();
  let user = that.find("input[name='user']").val();
  let consoleList = that.find('.jvc-consoleList').children();
  let cmdlogList = that.find('#jv-cmdlogHost').children();
  let logConfig = {};
  let logConfigType = that.find('#jv-selectLogConfig').attr('data-v');

  if (cmd) {
    obj['Cmd'] = splitargs(cmd);
  }

  if (entrypoint) {
    obj['Entrypoint'] = splitargs(entrypoint);
  } else {
    obj['Entrypoint'] = null;
  }

  if (workingDir) {
    obj['WorkingDir'] = workingDir;
  }
  if (user) {
    obj['User'] = user;
  }

  consoleList.each(function(i, e) {
    if ($(e).find('img').attr('src') == './image/radio_selected.png') {
      switch ($(e).find('img').attr('data-type')) {
        case '-i-t':
          obj.OpenStdin = true;
          obj.Tty = true;
          break;
        case '-i':
          obj.OpenStdin = true;
          obj.Tty = false;
          break;
        case '-t':
          obj.OpenStdin = false;
          obj.Tty = true;
          break;
        case 'none':
          obj.OpenStdin = false;
          obj.Tty = false;
          break;
        default:
      }
    }
  })

  if (logConfigType && logConfigType != 'none') {
    logConfig = {
      Type: logConfigType
    }
    let configT = {};
    if (cmdlogList.length) {
      cmdlogList.each(function(i, e) {
        let key = $(e).find("input[name='option']").val();
        let val = $(e).find("input[name='value']").val();
        configT[key] = val;
      })
      logConfig['Config'] = configT;
    }
    obj.HostConfig['LogConfig'] = logConfig;
  }

  if (logConfigType == 'none') {
    logConfig = {
      Type: logConfigType
    }
    obj.HostConfig['LogConfig'] = logConfig;
  }

}

//获取*镜像来源:
function getRegistries(that, target) {
  let t = '.selectControl';
  if (target == undefined || !target) {
    t = '.selectControl';
  } else {
    t = target + ' .selectControl';
  }
  var data = {
    cmd: 'docker_registries',
    "token": getCookie('PHPSESSID') || "",
  }
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(res) {
      var result = res.results.registry || [];
      var dft = res.results.default;
      if (result.length) {
        that.find(t).empty();

        if (dft == 0) {
          that.find(t).append('<option value="0" selected>DockerHub</option>');
        } else {
          that.find(t).append('<option value="0" >DockerHub</option>');
        }

        let dom = '';
        for (let i = 0; i < result.length; i++) {
          if (dft == result[i].Id) {
            dom += '<option value=' + result[i].Id + ' selected>' + result[i].Name + '</option>';
          } else {
            dom += '<option value=' + result[i].Id + '>' + result[i].Name + '</option>';
          }

        }
        that.find(t).append(dom);

        that.find(t).off("change").on('change', function() {
          registryDefault(that, $(this).val(), function() {

          });
        })

      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

//拉取镜像
function pullImage(that, fn) {

  let fromImage = that.find("input[name='registriesName']").val().toLowerCase();

  if (!fromImage) {
    errorMessageBox('请题写镜像名称');
    return;
  }

  if (!(/^[a-z0-9-._/]+(:[a-z0-9-._]+)?$/.test(fromImage))) {
    errorMessageBox('镜像名称不合法！');
    return;
  }

  let data = {
    fromImage: ''
  }

  if (imageNameInfo != null) {
    fromImage = imageNameInfo.URL + '/' + fromImage
  }

  if (fromImage.indexOf(':') == -1) {
    fromImage = fromImage + ':latest';
  }

  data.fromImage = fromImage;
  initCreateContainerData.fromImage = fromImage;

  if (!initCreateContainerData.isAutoPull) {
    if (typeof fn === 'function') {
      fn();
    } else {
      confirmCreateContainer(that);
    }
    return;
  }
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/images/create?fromImage=' + fromImage,
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      if (result) {}
    },
    complete: function() {
      if (typeof fn === 'function') {
        fn();
      } else {
        confirmCreateContainer(that);
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });
}

// 容器镜像选择:
function selectControl() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let v = $(t).val();
  if (v == 'DockerHub') {
    imageNameInfo = null;
  } else {
    imageNameInfo = JSON.parse(v);
  }
}

// 选择驱动程序:
function selectLogConfig() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let v = $(t).val();
  that_createContainer.find('#jv-selectLogConfig').attr('data-v', v);
}
//是否自动拉取镜像
function isAutoPullImage(t) {
  switchControl(t);
  if ($(t).hasClass('open')) {
    initCreateContainerData.isAutoPull = true;
  } else {
    initCreateContainerData.isAutoPull = false;
  }
}

function addcmdlogItem() {
  // let v = that_createContainer.find('#jv-selectLogConfig').attr('data-v');
  // if (!v || v == 'none') {
  //   return;
  // }
  addOption('#jv-cmdlogHost', 'jvt-cmdlog');
}
//添加选项
function addOption(host, tmp) {
  let len = new Date().getTime();
  wfTemplateAppend(that_createContainer.find(host), tmp, tmp + len);
}
//删除选项
function deleteDriverOption() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  $(t).parents('.jvc-volumeItemStlye').remove();
}


// 数据卷设置 ------------------------------------------------
function setVolumeBindData(that, obj) {
  let volumeDataList = that.find('#jv-volumeDataHost').children();
  let binds = [];
  let volumes = {};
  volumeDataList.each(function(i, e) {
    let containerType = $(e).attr('data-container').toLowerCase();
    let volumeType = $(e).attr('data-volume') == 'Writable' ? "" : 'ro';
    let vs = '';
    if (containerType == 'volume') {
      let containervalue = $(e).find("input[name='containervalue']").val();
      let optionValue = $(e).find(".volumeDataOption").attr('data-value');
      if (containervalue && optionValue) {
        vs = optionValue + ':' + containervalue;
        volumes[containervalue] = {};
      }
      if (volumeType) {
        vs = optionValue + ':' + containervalue + ':' + volumeType;
      }
    }
    if (containerType == 'bind') {
      let containerBindvalue = $(e).find("input[name='containervalue']").val();
      let hostValue = $(e).find("input[name='hostValue']").val();
      if (containerBindvalue && hostValue) {
        vs = hostValue + ':' + containerBindvalue;
        volumes[containerBindvalue] = {};
      }
      if (volumeType) {
        vs = hostValue + ':' + containerBindvalue + ':' + volumeType;
      }
    }
    if (vs) {
      binds.push(vs);
    }

  })
  obj.HostConfig.Binds = binds;
  obj.Volumes = volumes;
}

function navVolumeBind() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let typeV = $(t).attr('data-type');
  let typeB = $(t).addClass('selectnavBtnItem').siblings().attr('data-type');
  $(t).addClass('selectnavBtnItem').siblings().removeClass('selectnavBtnItem');
  $(t).parent().parent().parent().find('.volumeDataOption' + typeV).show();
  $(t).parent().parent().parent().find('.volumeDataOption' + typeB).hide();
  $(t).parent().parent().parent().attr('data-container', typeV);
}

function navWritableReadOnly() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let typeV = $(t).attr('data-lang');
  if (typeV == 'readOnly') {
    typeV = 'Read-only';
  } else {
    typeV = 'Writable';
  }
  $(t).addClass('selectnavBtnItem').siblings().removeClass('selectnavBtnItem');
  $(t).parent().parent().parent().attr('data-volume', typeV);
}

// 获取数据卷列表
function getVolume() {

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/volumes',
    type: "get"
  }
  return new Promise(function(resolve, reject) {
    postData(obj, {
      success: function(result) {
        // console.log(result);
        if (result) {
          $('.volumeDataOption').empty();
          if (result.Volumes.length) {
            let dom = '';
            for (let i = 0; i < result.Volumes.length; i++) {
              let info = result.Volumes[i];
              let str = info.Name;
              if (info.Name.length > 25) {
                str = info.Name.substr(0, 25) + '...';
              }
              dom += '<option value=' + info.Name + '>' + str + ' - ' + info.Driver + '</option>';
            }
            $('.volumeDataOption').attr('data-value', result.Volumes[0].Name);
            $('.volumeDataOption').val(result.Volumes[0].Name);
            $('.volumeDataOption').append(dom);
          }
          resolve(result);
        }
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);

      }
    });
  })

}
// ---------------------------------------------------------------------------------
//网络 ---------------------------------------------------------------------------------
function setNetworkData(that, obj) {
  let targetdom = that.find('#jv-otherSettingsNetwork');
  let wlms = targetdom.find("#jv-networoption").val();
  let rqmc = targetdom.find("#jv-networoptioncontainer .selectControl").attr('data-value');
  let hostname = targetdom.find("input[name='hostname']").val();
  let domainname = targetdom.find("input[name='domainname']").val();
  let macaddress = targetdom.find("input[name='macaddress']").val();
  let ipv4address = targetdom.find("input[name='ipv4address']").val();
  let ipv6address = targetdom.find("input[name='ipv6address']").val();
  let primarydnsserver = targetdom.find("input[name='primarydnsserver']").val();
  let secondarydnsserver = targetdom.find("input[name='secondarydnsserver']").val();
  let hostsFileEntries = targetdom.find('#jv-hostsFileEntries').children();
  if (hostname) {
    obj.Hostname = hostname;
  }
  if (domainname) {
    obj.Domainname = domainname;
  }
  if (macaddress) {
    obj.MacAddress = macaddress;
  }

  let dns = [],
    fv = [];
  if (primarydnsserver) {
    dns.push(primarydnsserver);
    obj.HostConfig.Dns = dns;
  }
  if (secondarydnsserver) {
    dns.push(secondarydnsserver);
    obj.HostConfig.Dns = dns;
  }

  hostsFileEntries.each(function(i, e) {
    fv.push($(e).find('input').val());
    obj.HostConfig.ExtraHosts = fv;
  })

  let networkModename = 'bridge'
  if (wlms) {
    networkModename = wlms;
  }
  if (rqmc) {
    networkModename = wlms + ':' + rqmc;
  }
  obj.HostConfig.NetworkMode = networkModename;

  let ipConfig = {
    IPAMConfig: {
      IPv4Address: '',
      IPv6Address: ''
    }
  }
  if (ipv4address) {
    ipConfig.IPAMConfig.IPv4Address = ipv4address;
  }
  if (ipv6address) {
    ipConfig.IPAMConfig.IPv6Address = ipv6address;
  }
  obj.NetworkingConfig.EndpointsConfig[networkModename] = ipConfig;

}

function selectNetworkPattern() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let v = $(t).val();
  if (v == 'container') {
    that_createContainer.find('#jv-networoptioncontainer').slideDown();
  } else {
    that_createContainer.find('#jv-networoptioncontainer').slideUp();
  }
  $(t).attr('data-value', v);
}

// 获取网络列表
function getNetworkOption(that) {
  return new Promise(function(resolve, reject) {
    let obj = {
      url: '../api/endpoints/' + globalData.tty + '/docker/networks',
      type: "get"
    }

    postData(obj, {
      success: function(result) {
        if (result) {
          let dom = '<option value="container">container</option>';
          for (let i = 0; i < result.length; i++) {
            let info = result[i];
            let str = info.Name;
            if (info.Name == 'bridge') {
              dom += '<option selected value=' + info.Name + '>' + info.Name + '</option>';
            } else {
              dom += '<option value=' + info.Name + '>' + info.Name + '</option>';
            }
          }
          that.find('#jv-networoption').append(dom);

          var xx = that.find('#jv-networoption option').sort(function(a, b) { //进行排序
            var aText = $(a).val();
            var bText = $(b).val();
            if (aText > bText) return 1;
            if (aText < bText) return -1;
            return 0;
          });
          that.find('#jv-networoption').empty(); //清空
          that.find('#jv-networoption').append(xx); //赋值
        }

        resolve('#jv-networoption');
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);

      }
    });
  });

}

//获取网络中容器列表
function getNetworkContainersList(that) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/json?all=0',
    type: "get",
  }
  postData(obj, {
    success: function(result) {
      if (result) {
        // console.log(result);
        let dom = '';
        for (let i = 0; i < result.length; i++) {
          let info = result[i];
          let str = info.Names.toString();
          if (str[0] == '/') {
            str = str.substr(1);
          }
          // JSON.stringify(info)
          dom += '<option value=' + str + ' id=' + info.Id + '>' + str + '</option>';
        }
        that.find('#jv-networoptioncontainer .selectControl').append(dom);
      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });

}

// ---------------------------------------------------------------------------------

//环境变量---------------------------------------------------------------------------

function setEnvironmentVariablesData(that, obj) {
  let env = [];
  let hjList = that.find('#jv-environmentVariablesHost').children();
  hjList.each(function(i, e) {
    let fooval = $(e).find("input[name='fooval']").val();
    let barval = $(e).find("input[name='barval']").val();
    env.push(fooval + '=' + barval);
  })
  obj.Env = env;
}
// ---------------------------------------------------------------------------------
//标签---------------------------------------------------------------------------
function setLabelsData(that, obj) {
  let labels = {};
  let labelList = that.find('#jv-labelsHost').children();
  labelList.each(function(i, e) {
    let fooval = $(e).find("input[name='fooval']").val();
    let barval = $(e).find("input[name='barval']").val();
    labels[fooval] = barval;
  })
  obj.Labels = labels;
}
// ---------------------------------------------------------------------------------
//重启策略---------------------------------------------------------------------------
function setRestartPolicyData(that, obj) {
  let restartPolicy = that.find('#jv-restartPolicy').children();
  restartPolicy.each(function(i, e) {
    if ($(e).find('img').attr('src') == './image/radio_selected.png') {
      obj.HostConfig.RestartPolicy.Name = $(e).find('img').attr('data-name');
    }
  })
}
// ---------------------------------------------------------------------------------
//运行和资源---------------------------------------------------------------------------
function setRuntimeResourcesData(that, obj) {
  let equipmentList = that.find('#jv-equipmentHost').children();
  let privileged = that.find('#jv-privilegedMode').hasClass('open');
  let devices = [];
  let runtime = that.find('#jv-runtimeResourcesSelect').attr('data-value') ? that.find('#jv-runtimeResourcesSelect').attr('data-value') : null;
  let memory = that.find('#jv-memoryLimit').val();
  let memoryReservation = that.find('#jv-memoryReservation').val();
  let nanoCpus = that.find('#jv-cpulimit').val();

  equipmentList.each(function(i, e) {
    let pathOnHost = $(e).find("input[name='hostname']").val();
    let pathInContainer = $(e).find("input[name='containerName']").val();
    devices.push({
      CgroupPermissions: "rwm",
      PathInContainer: pathInContainer,
      PathOnHost: pathOnHost
    })
  })
  obj.HostConfig.Devices = devices;
  obj.HostConfig.Runtime = runtime;
  obj.HostConfig.Privileged = privileged;
  obj.HostConfig['MemoryReservation'] = memoryReservation * 1024 * 1024;
  obj.HostConfig['Memory'] = memory * 1024 * 1024;
  obj.HostConfig['NanoCpus'] = nanoCpus * 1000000000;

}

// ---------------------------------------------------------------------------------
//功能---------------------------------------------------------------------------
function setCapabilitiesBtn(that) {
  let capAdd = ["AUDIT_WRITE", "CHOWN", "DAC_OVERRIDE", "FOWNER", "FSETID", "KILL", "MKNOD", "NET_BIND_SERVICE",
    "NET_RAW", "SETFCAP", "SETGID", "SETPCAP", "SETUID", "SYS_CHROOT"
  ]

  let capDrop = ["AUDIT_CONTROL", "BLOCK_SUSPEND", "DAC_READ_SEARCH", "IPC_LOCK", "IPC_OWNER", "LEASE", "LINUX_IMMUTABLE", "MAC_ADMIN", "MAC_OVERRIDE",
    "NET_ADMIN", "NET_BROADCAST", "SYSLOG", "SYS_ADMIN", "SYS_BOOT", "SYS_MODULE", "SYS_NICE", "SYS_PACCT", "SYS_PTRACE", "SYS_RAWIO", "SYS_RESOURCE",
    "SYS_TIME", "SYS_TTY_CONFIG", "WAKE_ALARM"
  ]
  that.find('#jv-capabilitiesHost').empty();
  let btnList = capAdd.concat(capDrop);
  for (let i = 0; i < btnList.length; i++) {
    var capabilitiesDom = wfTemplateAppend(that.find('#jv-capabilitiesHost'), 'jvt-gnSwitchItem', 'jvt-gnSwitchItem' + i);
    capabilitiesDom.find('.inputTitle').text(btnList[i] + ':');
    capabilitiesDom.find('.switch').attr('data-name', btnList[i]);
    for (let j = 0; j < capAdd.length; j++) {
      if (capAdd[j] == btnList[i]) {
        capabilitiesDom.find('.switch').addClass('open');
        capabilitiesDom.find('.switch-btn').addClass('right');
      }
    }
  }
}

function setCapabilitiesData(that, obj) {
  let capabilitiesList = that.find('#jv-capabilitiesHost').children();
  let capAdd = [];
  let capDrop = [];
  capabilitiesList.each(function(i, e) {
    if ($(e).find('.switch').hasClass('open')) {
      capAdd.push($(e).find('.switch').attr('data-name'));
    } else {
      capDrop.push($(e).find('.switch').attr('data-name'));
    }
  })
  obj.HostConfig['CapAdd'] = capAdd;
  obj.HostConfig['CapDrop'] = capDrop;
}
// ---------------------------------------------------------------------------------

// 获取容器基本数据
function getInfo(that) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/info',
    type: 'get'
  }
  postData(obj, {
    success: function(result) {
      if (result) {
        let dom = '';
        for (var variable in result.Runtimes) {
          if (result.Runtimes.hasOwnProperty(variable)) {
            dom += '<option value=' + variable + '>' + variable + '</option>';
          }
        }
        that.find('#jv-runtimeResourcesSelect').append(dom);

        var memTotal = parseInt(result.MemTotal / 1024 / 1024);
        that.find('.MemTotal').text(memTotal + 'MB');
        that.find('.NCPU').text(result.NCPU);
        that.find('.bfbval-1').attr('max', memTotal);
        that.find('.bfbval-2').attr('max', memTotal);
        that.find('.bfbval-3').attr('max', result.NCPU);
        that_createContainer.find('#jv-memoryReservation').jRange({
          from: 0,
          to: memTotal,
          step: 1,
          // width: 606,
          showLabels: true,
          showScale: true
        });
        that_createContainer.find('#jv-memoryLimit').jRange({
          from: 0,
          to: memTotal,
          step: 1,
          // width: 606,
          showLabels: true,
          showScale: true
        });
        that_createContainer.find('#jv-cpulimit').jRange({
          from: 0,
          to: result.NCPU,
          step: 0.25,
          // width: 606,
          showLabels: true,
          showScale: true
        });

      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

// 获取bind数据
function getCrporateCorporat(that, p, id) {
  that.find('#jv-subsidiaryDepartment').empty();
  return new Promise(function(resolve, reject) {
    var target = '';
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_folders"
    }
    if (id != undefined) {
      data["params"] = {
        "folder": p
      }
      target = '.jv-' + id;
      that.find(target).empty();
    } else {
      target = '#jv-' + 'subsidiaryDepartment';
      that.find(target).empty();
    }

    $.ajax({
      url: '../../unas-docker/includes/index.php', //接口
      type: "post", //GET或POST
      data: JSON.stringify(data), //数据
      dataType: 'json',
      success: function(result) {
        resolve(result);
        let info = result.results.dir || [];
        if (result.err == 0) {
          for (let i = 0; i < info.length; i++) {
            var s = info[i].replace(/[\ |\~|\`|\!|\@|\#|\$|\%|\^|\&|\*|\(|\)|\-|\_|\+|\=|\||\\|\[|\]|\{|\}|\;|\:|\"|\'|\,|\<|\.|\>|\/|\?]/g, "") + new Date().getTime();

            let subsidiaryItem = '';
            if (id == undefined) {
              subsidiaryItem = wfTemplateAppend(target, 'jvt-subsidiaryItem', 'jvt-subsidiaryItem-' + s + i);
            } else {
              subsidiaryItem = wfTemplateAppend(that.find(target), 'jvt-subsidiaryItem', 'jvt-subsidiaryItem-' + s + i + new Date().getTime());
            }
            subsidiaryItem.attr('data-id', s);
            subsidiaryItem.attr('data-p', info[i]);
            subsidiaryItem.attr('data-slide', 'up');
            subsidiaryItem.data({
              depId: info[i],
            });

            subsidiaryItem.find('.subsidiaryInput').text(info[i]).data({
              depId: info[i],
            });
            let pth = subsidiaryItem.find('.subsidiaryDepartment').parent().parent().attr('data-p');
            if (pth != undefined) {
              subsidiaryItem.find('.subsidiaryDepartment').attr('data-p', pth + '/' + info[i])
            } else {
              subsidiaryItem.find('.subsidiaryDepartment').attr('data-p', info[i]);
            }
            subsidiaryItem.find('.subsidiaryDepartment').attr('class', 'subsidiaryDepartment jv-' + s);

          }
        } else {

        }
      }, //回调成功方法
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })
}

function getDepartList(t) {
  let event = window.event || arguments.callee.caller.arguments[0];
  event.stopPropagation();
  let p = $(t).attr('data-p');
  if ($(t).attr('data-slide') == 'up') {
    $(t).attr('data-slide', 'down');
    $(t).find('.subsidiaryDepartment').slideDown();
    if ($(t).parent().attr('data-p') != undefined) {
      p = $(t).parent().attr('data-p') + '/' + $(t).attr('data-p');
    }
    getCrporateCorporat($(t), p, $(t).attr('data-id'));
  } else {
    $(t).attr('data-slide', 'up');
    $(t).find('.subsidiaryDepartment').slideUp();
    if ($(t).parent().attr('data-p') != undefined) {
      p = $(t).parent().attr('data-p') + '/' + $(t).attr('data-p');
    }
  }
  $(targetInput).val(p).attr('title', p);
}

function selectDir() {
  let event = window.event || arguments.callee.caller.arguments[0];
  event.stopPropagation();
  targetInput = $(event.target);
  $(targetInput).parent().parent().siblings().find('.subsidiaryDepartment-host').slideUp();
  $(targetInput).siblings('.subsidiaryDepartment-host').slideToggle();
}

function hiddenDir() {
  let event = window.event || arguments.callee.caller.arguments[0];
  event.stopPropagation();
  let t = $(event.target);
}
$(document).click(function(event) {
  event.stopPropagation();
  $('.subsidiaryDepartment-host').slideUp();
})
