var editContainerInfo = {};
var ishide = false;
//修改容器
function modifyContainer(result) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = {};
  var  titledom = '<span data-lang="duplicateEdit">修改容器</span>'
  if (event != undefined) {
    t = event.currentTarget;
  }
  if ($(t).data('dataInfo')) {
    containerInfo = JSON.parse($(t).data('dataInfo'));
    initData.is_import = false;
    initData.is_openimage = false;
  }else {
    titledom = '<span data-lang="importcontainer">导入容器</span>'
  }

  that_createContainer = showSecondModel({
    title: titledom,
    oemplateName: 'jvt-createContainer',
    id: 'jv-createContainer',
    isShowApplicationBtn: true,
    isShowFooterBtn: true,

  }, function(e) {
    if (e) {
      if (initData.is_import) {
        // pullImage(that_createContainer);
        confirmCreateContainer(that_createContainer);
      } else {
        editContainer(editContainerInfo.Id, that_createContainer.find('#jv-generalSettings input[name=containerName]').val());
      }
    }

  })
  that_createContainer.find('.jvc-consoleList img').click(function(e) {
    $(this).attr('src', './image/radio_selected.png').parent().siblings().find('img').attr('src', './image/radio.png');
  });
  that_createContainer.find('#jv-registriesName').attr('disabled', 'true');
  that_createContainer.find('#jv-isAutoPullImageBtn').hide();
  that_createContainer.find('#jv-registrySource').hide();

  that_createContainer.find('#jv-restartPolicy img').click(function(e) {
    $(this).attr('src', './image/radio_selected.png').parent().siblings().find('img').attr('src', './image/radio.png');
  });

  $('body').on('click', '.containerSetNavItem', function(e) {
    let t = $(e.currentTarget);
    let i = $(e.currentTarget).index();
    t.addClass('currentcontainerSetNavItem').siblings().removeClass('currentcontainerSetNavItem');
    that_createContainer.find('.settingItem').eq(i).show().siblings().hide();
  })

  $('body').on('click', '.otherSettingsNavItem', function(e) {
    let t = $(e.currentTarget);
    let i = $(e.currentTarget).index();
    t.addClass('currentotherSettingsNavItem').siblings().removeClass('currentotherSettingsNavItem');
    that_createContainer.find('.otherSettingsContentItem').eq(i).show().siblings().hide();
  })

  getNetworkOption(that_createContainer).then(function(res){

    if (initData.is_import) {
      refreshContainerData(that_createContainer, result);
      if (initData.is_openimage) {
        initCreateContainerData.isAutoPull = true;
        if (is_tar) {
          that_createContainer.find('#jv-isAutoPullImageBtn').hide();
        }else {
          that_createContainer.find('#jv-isAutoPullImageBtn').show();
        }

        that_createContainer.find("#jv-isAutoPullImageBtn .switch").addClass("open").children(".switch-btn").addClass("right");
      }
      that_createContainer.find('#jv-registrySource').hide();
      that_createContainer.find('#jv-registriesName').attr('disabled', 'disabled');
    } else {
      initContainerData(that_createContainer);
    }
  });

  getRegistries(that_createContainer, '#jv-generalSettings');

  getNetworkContainersList(that_createContainer);
}

function initContainerData(that) {

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + containerInfo.Id + '/json',
    type: "get",
  }

  postData(obj, {
    success: function(result) {
      refreshContainerData(that, result);
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });

}

function refreshContainerData(that, result) {

  if (result) {
    editContainerInfo = result;
    let name = result.Name.toString();
    if (name[0] == '/') {
      name = name.substr(1);
    }
    that.find("input[name='containerName']").val(name);
    that.find("input[name='registriesName']").val(result.Config.Image);
    if (result.HostConfig.PublishAllPorts) {
      that.find("#jv-publishAllPorts").addClass("open").children(".switch-btn").addClass("right");
    } else {
      that.find("#jv-publishAllPorts").removeClass("open").children(".switch-btn").removeClass("right");
    }
    setTimeout(function() {
      var p_index = 0;
      for (let variable in result.HostConfig.PortBindings) {
        if (result.HostConfig.PortBindings.hasOwnProperty(variable)) {
          let portBinding = result.HostConfig.PortBindings[variable][0];
          let key = variable.split('/');
          let sdwldkHost = wfTemplateAppend(that.find('#jv-sdwldkHost'), 'jvt-sdwldk', 'jvt-sdwldk' + key[0] + p_index);
          let hostIp = portBinding.HostIp ? portBinding.HostIp + ':' : '';
          sdwldkHost.find("input[name='host']").val(hostIp + portBinding.HostPort);
          sdwldkHost.find("input[name='contalner']").val(key[0]);

          sdwldkHost.find('.selectControlTcpUdp').attr('data-value', key[1])

          sdwldkHost.find('.selectControlTcpUdp option').each(function(i, e) {
            if ($(e).val() == key[1]) {
              $(e).attr('selected', 'selected');
            }
          })

        }
        p_index++;
      }
    }, 400);
    if (result.HostConfig.AutoRemove) {
      that.find("#jv-autoRemove").addClass("open").children(".switch-btn").addClass("right");
    } else {
      that.find("#jv-autoRemove").removeClass("open").children(".switch-btn").removeClass("right");
    }

    initCommandLogging(that, result);
    getVolume().then(function(res){
      initMounts(that, result);
    });
    setTimeout(function() {
      initNetwork(that, result)
    }, 300);
    initEnv(that, result);
    initLabels(that, result);
    initRestartPolicy(that, result);
    initRuntimeResources(that, result);
    initCapabilitiesBtn(that, result);
    getInfo(that_createContainer);

  }
}

//初始化命令和日志记录数据
function initCommandLogging(that, result) {

  let cmds = '',
    entrypoints = '';
  if (result.Config.Cmd) {
    if ((typeof result.Config.Cmd == 'object') && result.Config.Cmd.constructor == Array) {
      cmd_parts = [];
      result.Config.Cmd.forEach(element => {
        if (element.search(' ') != -1){
          cmd_parts.push('"' + element + '"');
        }else{
          cmd_parts.push(element);
        }
      });
      cmds = cmd_parts.join(' ');
    }
    if ((typeof result.Config.Cmd == 'string') && result.Config.Cmd.constructor == String) {
      cmds = result.Config.Cmd;
    }
  }

  if (result.Config.Entrypoint) {
    if ((typeof result.Config.Entrypoint == 'object') && result.Config.Entrypoint.constructor == Array) {
      entrypoint_parts = [];
      result.Config.Entrypoint.forEach(element => {
        if (element.search(' ') != -1){
          entrypoint_parts.push('"' + element + '"');
        }else{
          entrypoint_parts.push(element);
        }
      });
      entrypoints = entrypoint_parts.join(' ');
    }
    if ((typeof result.Config.Entrypoint == 'string') && result.Config.Entrypoint.constructor == String) {
      entrypoints = result.Config.Entrypoint;
    }
  }

  that.find("input[name='cmd']").val(cmds);
  that.find("input[name='entrypoint']").val(entrypoints);
  that.find("input[name='workingDir']").val(result.Config.WorkingDir);
  that.find("input[name='user']").val(result.Config.User);
  let consoleList = that.find('.jvc-consoleList').children();

  consoleList.each(function(i, e) {
    $(e).find('img').attr('src', './image/radio.png');
    if (result.Config.OpenStdin && result.Config.Tty) {
      $(e).find('img[data-type="-i-t"]').attr('src', './image/radio_selected.png');
    }

    if (result.Config.OpenStdin && !result.Config.Tty) {
      $(e).find('img[data-type="-i"]').attr('src', './image/radio_selected.png');

    }

    if (!result.Config.OpenStdin && result.Config.Tty) {
      $(e).find('img[data-type="-t"]').attr('src', './image/radio_selected.png');
    }

    if (!result.Config.OpenStdin && !result.Config.Tty) {
      $(e).find('img[data-type="none"]').attr('src', './image/radio_selected.png');
    }

  })

  that.find('#jv-selectLogConfig option').each(function(i, e) {
    if ($(e).val() == result.HostConfig.LogConfig.Type) {
      $(e).attr('selected', 'selected');
      that.find('#jv-selectLogConfig').attr('data-v', result.HostConfig.LogConfig.Type);
    }
  });

  let logConfigTypes = result.HostConfig.LogConfig.Config;
  let len = 0;
  for (let variable in logConfigTypes) {
    if (logConfigTypes.hasOwnProperty(variable)) {
      let logConfigDom = wfTemplateAppend(that.find('#jv-cmdlogHost'), 'jvt-cmdlog', 'jvt-cmdlog' + len);
      logConfigDom.find("input[name='option']").val(variable);
      logConfigDom.find("input[name='value']").val(logConfigTypes[variable]);
    }
    len++;
  }

}

// 初始化数据卷
function initMounts(that, result) {
  let mounts = result.Mounts;
  for (let i = 0; i < mounts.length; i++) {
    let mountsData = mounts[i];
    let mountsDom = wfTemplateAppend(that.find('#jv-volumeDataHost'), 'jvt-volumeDataItem', 'jvt-volumeDataItem' + i);
    mountsDom.find("input[name='containervalue']").val(mountsData.Destination);
    mountsDom.attr('data-container', mountsData.Type);
    if (mountsData.RW) {
      mountsDom.attr('data-volume', 'Writable');
    } else {
      mountsDom.attr('data-volume', 'Read-only');
    }

    mountsDom.find('.containertopNavBtnList').children().each(function(i, e) {
      if ($(e).attr('data-type').toLowerCase() == mountsData.Type.toLowerCase()) {
        $(e).addClass('selectnavBtnItem').siblings().removeClass('selectnavBtnItem');
      }
    });

    let volumeDataOptionType = '';
    if (mountsData.Type == 'volume') {
      mountsDom.find('.volumeDataOptionVolume').show();
      mountsDom.find('.volumeDataOptionBind').hide();
      mountsDom.find('.volumeDataOption').attr('data-value', mountsData.Name);
      mountsDom.find('.volumeDataOption option').each(function(i, e) {
        if ($(e).val() == mountsData.Name) {
          $(e).attr('selected', 'selected');
        }
      });
      volumeDataOptionType = '.volumeDataOptionVolume .topNavBtnList';
    }

    if (mountsData.Type == 'bind') {
      mountsDom.find('.volumeDataOptionBind').show();
      mountsDom.find('.volumeDataOptionVolume').hide();
      mountsDom.find("input[name='hostValue']").val(mountsData.Source);
      volumeDataOptionType = '.volumeDataOptionBind .topNavBtnList';
    }


    mountsDom.find(volumeDataOptionType).children().each(function(i, e) {
      var pnode = $(e).parent().parent().parent();
      var rwtype = pnode.attr('data-volume');
      let typeV = $(e).attr('data-lang');
      if (typeV == 'readOnly') {
        typeV = 'Read-only';
      } else {
        typeV = 'Writable';
      }

      if (rwtype == typeV) {
        $(e).addClass('selectnavBtnItem').siblings().removeClass('selectnavBtnItem');
      }

    });

  }
}
// 初始化网络 ExtraHosts
function initNetwork(that, result) {
  let extraHosts = result.HostConfig.ExtraHosts || [];
  that.find("#jv-otherSettingsNetwork input[name='hostname']").val(result.Config.Hostname);
  that.find("input[name='domainname']").val(result.Config.Domainname);
  that.find("input[name='macaddress']").val(result.Config.MacAddress);
  result.HostConfig.Dns = result.HostConfig.Dns || [];
  that.find("input[name='primarydnsserver']").val(result.HostConfig.Dns[0]);
  that.find("input[name='secondarydnsserver']").val(result.HostConfig.Dns[1]);
  that.find("#jv-networoption").attr('data-value', result.HostConfig.NetworkMode);

  var container_id = '';
  var networkMode = result.HostConfig.NetworkMode
  if (result.HostConfig.NetworkMode.indexOf('container') > -1) {
    result.HostConfig.NetworkMode = networkMode.split(':')[0];
    container_id = networkMode.split(':')[1];
  }

  for (let networks in result.NetworkSettings) {
    if (result.NetworkSettings.hasOwnProperty(networks)) {
      if (networks == 'Networks') {
        for (var variable in result.NetworkSettings[networks]) {
          if (result.NetworkSettings[networks].hasOwnProperty(variable)) {
            for (var ipS in result.NetworkSettings[networks][variable]) {
              if (result.NetworkSettings[networks][variable].hasOwnProperty(ipS)) {
                if (ipS == 'IPAMConfig') {
                  if (result.NetworkSettings[networks][variable][ipS]) {
                    that.find("input[name='ipv4address']").val(result.NetworkSettings[networks][variable][ipS].IPv4Address);
                    that.find("input[name='ipv6address']").val(result.NetworkSettings[networks][variable][ipS].IPv6Address);
                  }
                }
              }
            }
          }
        }
      }
    }
  }

  that.find('#jv-networoption option').each(function(i, e) {
    if ($(e).val() == result.HostConfig.NetworkMode) {
      $(e).prop("selected",true);
    }
  })

  if (result.HostConfig.NetworkMode == 'container') {
    that.find('#jv-networoptioncontainer').slideDown();
    that.find('#jv-networoptioncontainer option').each(function(i, e) {
      if (e.id == container_id) {
        $(e).prop("selected",true);
      }
    })
    that.find("#jv-otherSettingsNetwork input[name='hostname']").val('');
  } else {
    that.find('#jv-networoptioncontainer').slideUp();
  }

  for (let i = 0; i < extraHosts.length; i++) {
    let extraHostsDom = wfTemplateAppend(that.find('#jv-hostsFileEntries'), 'jvt-hostsFileEntriesItem', 'jvt-hostsFileEntriesItem' + i);
    extraHostsDom.find("input[name='value']").val(extraHosts[i]);
  }


}

// 初始化环境变量
function initEnv(that, result) {
  let envs = result.Config.Env || [];
  for (var i = 0; i < envs.length; i++) {
    var j = envs[i].indexOf('=');
    var envData = [envs[i].slice(0, j), envs[i].slice(j + 1)];
    // let envData = envs[i].split('=');
    let envDom = wfTemplateAppend(that.find('#jv-environmentVariablesHost'), 'jvt-environmentVariablesItem', 'jvt-environmentVariablesItem' + i);
    envDom.find("input[name='fooval']").val(envData[0]);
    envDom.find("input[name='barval']").val(envData[1]);
  }
}

// 初始化标签
function initLabels(that, result) {
  let labels = result.Config.Labels || {};
  let i = 0;
  for (var variable in labels) {
    if (labels.hasOwnProperty(variable)) {
      let labelsDom = wfTemplateAppend(that.find('#jv-labelsHost'), 'jvt-labelsItem', 'jvt-labelsItem' + i);
      labelsDom.find("input[name='fooval']").val(variable);
      labelsDom.find("input[name='barval']").val(labels[variable]);
    }
    i++;
  }
}

// 初始化重启策略
function initRestartPolicy(that, result) {
  let restartPolicy = that.find('#jv-restartPolicy').children();
  restartPolicy.each(function(i, e) {
    if (result.HostConfig.RestartPolicy.Name == $(e).find('img').attr('data-name')) {
      $(e).find('img').attr('src', './image/radio_selected.png');
    } else {
      $(e).find('img').attr('src', './image/radio.png');
    }
  })
}

// 初始化运行资源
function initRuntimeResources(that, result) {

  if (result.HostConfig.Privileged) {
    that.find("#jv-privilegedMode").toggleClass("open").children(".switch-btn").toggleClass("right");
  }
  result.HostConfig.Devices = result.HostConfig.Devices || [];
  for (var i = 0; i < result.HostConfig.Devices.length; i++) {
    let deviceInfo = result.HostConfig.Devices[i];

    let deviceDom = wfTemplateAppend(that.find('#jv-equipmentHost'), 'jvt-equipmentItem', 'jvt-equipmentItem' + i);
    deviceDom.find("input[name='hostname']").val(deviceInfo.PathOnHost);
    deviceDom.find("input[name='containerName']").val(deviceInfo.PathInContainer);
  }

  setTimeout(function() {
    if (result.HostConfig.Runtime) {
      that.find('#jv-runtimeResourcesSelect').attr('data-value', result.HostConfig.Runtime);
      that.find('#jv-runtimeResourcesSelect option').each(function(i, e) {
        if ($(e).val() == result.HostConfig.Runtime) {
          $(e).attr('selected', 'selected');
        }
      })

    } else {
      that.find('#jv-runtimeResourcesSelect').attr('data-value', null);
    }
  }, 500)

  that.find('#jv-memoryReservation').val(result.HostConfig.MemoryReservation / 1024 / 1024);
  that.find('#jv-memoryLimit').val(result.HostConfig.Memory / 1024 / 1024);
  that.find('#jv-cpulimit').val(result.HostConfig.NanoCpus / 1000000000);

}

// ---------------------------------------------------------------------------------
//功能---------------------------------------------------------------------------
function initCapabilitiesBtn(that, result) {

  let capAdd = result.HostConfig.CapAdd || ["AUDIT_WRITE", "CHOWN", "DAC_OVERRIDE", "FOWNER", "FSETID", "KILL", "MKNOD", "NET_BIND_SERVICE",
    "NET_RAW", "SETFCAP", "SETGID", "SETPCAP", "SETUID", "SYS_CHROOT"
  ];

  let capDrop = result.HostConfig.CapDrop || ["AUDIT_CONTROL", "BLOCK_SUSPEND", "DAC_READ_SEARCH", "IPC_LOCK", "IPC_OWNER", "LEASE", "LINUX_IMMUTABLE", "MAC_ADMIN", "MAC_OVERRIDE",
    "NET_ADMIN", "NET_BROADCAST", "SYSLOG", "SYS_ADMIN", "SYS_BOOT", "SYS_MODULE", "SYS_NICE", "SYS_PACCT", "SYS_PTRACE", "SYS_RAWIO", "SYS_RESOURCE",
    "SYS_TIME", "SYS_TTY_CONFIG", "WAKE_ALARM"
  ];

  that.find('#jv-capabilitiesHost').empty();
  let btnList = capAdd.concat(capDrop);
  for (let i = 0; i < btnList.length; i++) {
    var capabilitiesDom = wfTemplateAppend(that.find('#jv-capabilitiesHost'), 'jvt-gnSwitchItem', 'jvt-gnSwitchItem' + i);
    capabilitiesDom.find('.inputTitle').text(btnList[i] + ':');
    capabilitiesDom.find('.switch').attr('data-name', btnList[i]);
    for (let j = 0; j < capAdd.length; j++) {
      if (capAdd[j] == btnList[i]) {
        capabilitiesDom.find('.switch').addClass('open');
        capabilitiesDom.find('.switch-btn').addClass('right');
      }
    }
  }
}


//备份
function backups(id, name) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + id + '/rename?name=' + name + '-old',
    type: "post",
  }
  postData(obj, {
    success: function(result) {

    },
    complete: function(xhr, textStatus) {

      if (xhr.status == 200 || xhr.status == 204) {
        pullImage(that_createContainer, function() {
          confirmCreateContainer(that_createContainer, function() {

            let obj = {
              url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + id + '?force=true&v=1',
              type: "DELETE",
            }
            postData(obj, {
              success: function(result) {
                if (result) {

                }

              },
              complete: function(xhr, textStatus) {
                if (xhr.status == 200 || xhr.status == 204) {
                  if (ishide) {
                    closePopup();
                  }
                }
                getData();

                ishide = false;
              },
              error: function(xhr, textStatus) {
                console.log(xhr);
                console.log(textStatus);
              }
            });

          }, function() {
            restore(id, name);
          });
        })
      }
    },
    error: function(xhr, textStatus) {
      restore(id, name);
    }
  });
}
//还原
function restore(id, name) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + id + '/rename?name=' + name,
    type: "post",
  }
  postData(obj, {
    success: function(result) {

    },
    complete: function(xhr, textStatus) {
      if (xhr.status == 200 || xhr.status == 204) {

      }
      getData();
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

// 重建容器
function recreateContainer() {
  modifyContainer();
  $('#jv-secondPopup').hide();
  ishide = true;
  let resTime = setInterval(function() {
    if (editContainerInfo.Id && that_createContainer.find('#jv-generalSettings input[name=containerName]').val()) {
      backups(editContainerInfo.Id, editContainerInfo.Name);
      clearInterval(resTime);
    }
  }, 50);
}

//编辑容器
function editContainer(id, name){
  let fromImage = that_createContainer.find('#jv-registriesName').val().toLowerCase();

  let autoRemove = that_createContainer.find("#jv-autoRemove").hasClass('open'); //自动删除
  let publishAllPorts = that_createContainer.find("#jv-publishAllPorts").hasClass('open'); //同步主机开放端口
  let networkPortPublishingList = that_createContainer.find('#jv-sdwldkHost').children();
  let networkPortPublishingData = manualNetworkPortPublishing(networkPortPublishingList); //手动网络端口发布

  var fromContainerData = {
    Image: fromImage,
    Env: [],
    ExposedPorts: networkPortPublishingData.exposedPorts,
    HostConfig: {
      AutoRemove: autoRemove, //自动删除
      Binds: [],
      Devices: [],
      Dns: [],
      PublishAllPorts: publishAllPorts, //同步主机开放端口
      PortBindings: networkPortPublishingData.portBindings,
      ExtraHosts: [],
      RestartPolicy: {
        Name: "no"
      },
      Init: false,
      Privileged: false,
      Runtime: null,
    },
    NetworkingConfig: {
      EndpointsConfig: {}
    },
    Labels: {},
    Volumes: {},
    name: name,
    OpenStdin: false,
    Tty: false,
  }
  setCommandLogging(that_createContainer, fromContainerData);
  setVolumeBindData(that_createContainer, fromContainerData);
  setNetworkData(that_createContainer, fromContainerData);
  setEnvironmentVariablesData(that_createContainer, fromContainerData);
  setLabelsData(that_createContainer, fromContainerData);
  setRestartPolicyData(that_createContainer, fromContainerData);
  setRuntimeResourcesData(that_createContainer, fromContainerData);
  setCapabilitiesData(that_createContainer, fromContainerData);

  return new Promise(function(resolve, reject){
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_edit",
      "params": {
        "name": name,
        "container": id,
        "config": fromContainerData
      }
    };
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }

    postData(obj, {
      success: function(result) {
        let immediatelyTime = null;
        if (that_createContainer.find("#jv-startImmediately").hasClass('open')) {
          immediatelyTime = setInterval(function() {
            if (result.results && result.results.Id) {
              dockerContainerControl(result.results.Id, 'start');
            } else if (result.errmsg && result.errmsg.message) {
              errorMessageBox(result.errmsg.message);
            }
            clearInterval(immediatelyTime);
          }, 300);
        }
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })
}
