var shopData = {
  list: [], //列表数据
  count: 0, //列表总数
  curr: 1, //当前页
  limit: 1000000, //每页数量
  checkCount: 0, //已选列表数量
  deleteName: [], //保存删除列表名称
  pullingList: []
}
var appAssort = {};
var confInfo = {};
var ckdom = [];
var imageNameS = [];
var containerNameS = [];
var currentApp = null;
var currentAppdetail = null;
globalData.hashName = location.hash.split("?")[0].split("#")[1];
// 获取商店信息
function getUnasapp() {

  var data = {
    v: 1,
    act: 'list'
  }
  let obj = {
    url: '/unas-docker/store/',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(res) {

      if (res.err == 0) {
        var info = res.results || [];

        appAssort = {
          'all': [],
          'misc': [],
          'multimedia': [],
          'utils': [],
          'games': [],
          'network': [],
          'graphics': [],
          'office': [],
          'programming': [],
        }
        appAssort.all = info;
        $('#jv-d-tbodybox').empty();
        shopData.list = info;
        shopData.count = info.length;
        refreshInfo(info, shopData.count, shopData.curr);

        for (var i = 0; i < info.length; i++) {
          var temp = info[i];
          temp.section = temp.section.toLowerCase();
          switch (temp.section) {
            case 'multimedia':
              appAssort.multimedia.push(temp);
              break;
            case 'utils':
              appAssort.utils.push(temp);
              break;
            case 'games':
              appAssort.games.push(temp);
              break;
            case 'network':
              appAssort.network.push(temp);
              break;
            case 'graphics':
              appAssort.graphics.push(temp);
              break;
            case 'office':
              appAssort.office.push(temp);
              break;
            case 'programming':
              appAssort.programming.push(temp);
              break;
            default:
              appAssort.misc.push(temp);
          }
        }

      } else {

      }
      hideLoading();

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
      hideLoading();
    }
  }, false);
}

var timeShow = null;
//数据更新
function refreshInfo(data, count, curr) {

  layui.use('laypage', function() {
    var laypage = layui.laypage;
    laypage.render({
      elem: 'jv-paging',
      count: count, //数据总数，从服务端得到,
      limit: shopData.limit,
      curr: curr,
      prev: ' ', //若不显示，设置false即可
      next: ' ', //若不显示，设置false即可
      jump: function(obj, first) {
        //obj包含了当前分页的所有参数，比如：
        // obj.limit 得到每页显示的条数
        shopData.curr = obj.curr; //得到当前页，以便向服务端请求对应页的数据。
        var lang = localStorage.getItem('lang') || 'cn';
        $('#jv-gopage').text(obj.curr);
        $('#jv-pageitemV').text(shopData.limit);
        let t = arrTrans(shopData.limit, data);
        $('#jv-d-tbodybox').empty();
        $('#jv-checkboxAll').prop("checked", false);
        if (data.length) {
          var len = t[shopData.curr - 1].length;
          var ispulling = 0;
          for (var i = 0; i < len; i++) {
            let info = t[shopData.curr - 1][i];
            info.section = info.section.toLowerCase();
            var networkDom = wfTemplateAppend('#jv-d-tbodybox', 'jvt-d-tr', 'jvt-d-tr' + i);
            networkDom.find('.jvc-checkbox').data('dataInfo', info);
            networkDom.data('dataInfo', info);
            info.logo && networkDom.find('.jvc-logo').attr('src', info.logo);

            if (info.name_language) {
              if (info.name_language[lang]) {
                networkDom.find('.jvc-s-name').text(info.name_language[lang]).attr('title', info.name_language[lang]);
              }else {
                networkDom.find('.jvc-s-name').text(info.name).attr('title', info.name);
              }

            }else {
              networkDom.find('.jvc-s-name').text(info.name).attr('title', info.name);
            }

            networkDom.find('.jvc-version').text(info.version);
            networkDom.find('.jvc-apptype').attr('data-lang', info.section);
            if (info.description_language) {
              networkDom.find('.jvc-description').text(info.description_language[lang]);
              networkDom.find('.jvc-detailtext').text(info.description_language[lang]);
            } else {
              networkDom.find('.jvc-description').text(info.description);
              networkDom.find('.jvc-detailtext').text(info.description);
            }

            networkDom.find('.jvc-image').text(info.image).attr('title', info.image);
            networkDom.find('.jvc-link_manual').text(info.link_manual).on('click', function() {
              jQuery('#jv-link_manual-box').find('iframe').attr('src', jQuery(this).text())
              jQuery('#jv-link_manual-box').show();
            });
            var image = info.image ? info.image.toString() : "";
            networkDom.find('.jvc-author').text(info.author);
            networkDom.find('.jvc-slogan').text(info.slogan || "");

            // app详情
            networkDom.on('click', function(e) {
              e.stopPropagation();
              var app_self = jQuery(this);
              var appinfo = jQuery(this).data('dataInfo');
              var appdetail_self = $('#jv-appdetail-box').show();
              var apptype_xq = app_self.find('.jvc-apptype').text();
              currentApp = app_self;
              currentAppdetail = appdetail_self;
              appdetail_self.find('.jvc-appnema').text(appinfo.name);
              appdetail_self.find('.jvc-logo').attr('src', appinfo.logo);
              appdetail_self.find('.jvc-author').text(appinfo.author);
              appdetail_self.find('.jvc-version').text(appinfo.version);
              appdetail_self.find('.jvc-image').text(appinfo.image);
              appdetail_self.find('.jvc-apptype').text(apptype_xq);

              if (appinfo.description_language) {
                appdetail_self.find('.jvc-description').text(appinfo.description_language[lang]);
                appdetail_self.find('.jvc-detailtext').text(appinfo.description_language[lang]);
              } else {
                appdetail_self.find('.jvc-description').text(appinfo.description);
                appdetail_self.find('.jvc-detailtext').text(appinfo.description);
              }
              appdetail_self.find('.jvc-link_manual').text(appinfo.link_manual).on('click', function() {
                jQuery('#jv-link_manual-box').find('iframe').attr('src', jQuery(this).text())
                jQuery('#jv-link_manual-box').show();
              });

              setDownloadStatus(app_self, appdetail_self);

              appdetail_self.find('.jvc-expressinstall').off('click').on('click', function(ev) {
                ev.stopPropagation();
                expressinstall(app_self);

              });

              appdetail_self.find('.jvc-standardinstall').on('click', function(e) {
                e.stopPropagation();
                installContainer(app_self);

              });

            })
            // 一键安装
            networkDom.find('.jvc-expressinstall').on('click', function(e) {
              e.stopPropagation();
              var pn = jQuery(this).closest('div.app-item');
              pn.find('.jvc-bar-txt').text('0%');
              pn.find('.jvc-bar-w').css('width', '0%');
              expressinstall(jQuery(this).closest('div.app-item'));
            });
            // 手动安装
            networkDom.find('.jvc-standardinstall').on('click', function(e) {
              e.stopPropagation();
              var pn = jQuery(this).closest('div.app-item');
              pn.find('.jvc-bar-txt').text('0%');
              pn.find('.jvc-bar-w').css('width', '0%');
              installContainer(jQuery(this).closest('div.app-item'));
              jQuery(this).hide();
            });
            //更多操作
            networkDom.find('.jvc-moreop').on('click', function(e) {
              e.stopPropagation();
              jQuery(this).siblings().toggle();
            });
            //查看详细
            networkDom.find('.jvc-checkdes').on('click', function(e) {
              e.stopPropagation();
              var n = jQuery(this).closest('div.app-item');
              n.find('.jvc-desdetail').slideDown();
            });
            //关闭详细
            networkDom.find('.closedes').on('click', function(e) {
              e.stopPropagation();
              var n = jQuery(this).closest('div.app-item');
              n.find('.jvc-desdetail').slideUp();
            });

          }

          docker_installing($('#jv-d-tbodybox')).then(function(data) {});

          searShopData('#jv-searShop');
          jQuery('#jv-pageList').html('');
          for (var p = 1; p <= obj.pages; p++) {
            var mi = document.createElement("li");
            jQuery(mi).text(p);
            jQuery('#jv-pageList').append(mi);

            mi.onclick = function() {
              shopData.curr = jQuery(this).text();
              refreshInfo(data, count, shopData.curr);
            }

          }

          $('#jv-pageitemList').children().each(function(i, e) {
            e.onclick = function() {
              shopData.limit = jQuery(e).text();
              refreshInfo(data, count, shopData.curr);
            }
          })


          setTimeout(function() {
            $('#jv-d-tbodybox').children().each(function(i, e) {
              var h = $(e).find('.jvc-description')[0].offsetHeight;
              if (h > 34) {
                $(e).find('.show—all').show();
              } else {
                $(e).find('.show—all').hide();
              }
            })
          }, 300)
          $('#jv-volumeNull').hide();
        } else {
          $('#jv-volumeNull').show();
          $('#jv-footerPage').hide();
        }

        if (obj.pages > 1 && obj.count) {
          $("#jv-paging").show();
          $('#jv-footerPage').show();
        } else {
          $("#jv-paging").hide();
          $('#jv-footerPage').hide();
        }


        changeLanguage(lang, function(){
          refreshInfo(data, count, shopData.curr);
        });

        //首次不执行
        if (!first && first != undefined) {
          refreshInfo(data, count, shopData.curr);
        }
      }
    });
  });

}

// 刷新
function refreshShopData() {
  showLoading();
  shopData.curr = 1;
  $('input[name=searshop]').val('');
  getImglist().then(function(imageS) {
    getUnasapp(1, 'list', null);
  });

  jQuery('#jv-classifylist li').eq(0).attr('class', 'nav_on').siblings().removeClass('nav_on');

}

function installimage_list(that) {
  jQuery('#jv-d-tbodybox input[type=checkbox]:checked').each(function(i, e) {
    pullImage_shop(e);
  })
}
//手动安装
function installContainer(e) {
  var id = "";
  var info = $(e).data('dataInfo');
  id = info.id;

  var data = {
    v: 1,
    act: 'json',
    param: {
      id: id
    }
  }
  let obj = {
    url: '/unas-docker/store/',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(res) {
      globalData.isImage = false;
      $('#jv-popup').css('top', '0');
      createContainer();
      // that_createContainer.parents('.modal-body').find('.box-footer').hide();
      var d = '<a class="btn jvc-stepP disabledbtn" href="javascript:void(0);" data-lang="prev"></a>' +
        '<a class="btn jvc-stepN" href="javascript:void(0);" data-lang="next"></a>' +
        '<a class="btn subBtn none jvc-finish" href="javascript:void(0);" data-lang="finish"></a>'
      that_createContainer.parents('.modal-body').find('#jv-footer-btn').html(d);
      var step = 0;
      that_createContainer.parents('.modal-body').find('.jvc-stepP').on('click', function(e) {
        step--;
        if (step <= 0) {
          $(this).addClass('disabledbtn');
          step = 0;
        } else {
          $(this).removeClass('disabledbtn');
        }
        that_createContainer.parents('.modal-body').find('.jvc-stepN').show();
        that_createContainer.parents('.modal-body').find('.jvc-finish').hide();
        that_createContainer.find('.jvc-step').hide();
        that_createContainer.find('.step-' + step).show();
      })
      that_createContainer.parents('.modal-body').find('.jvc-stepN').on('click', function(e) {
        if (!that_createContainer.find("input[name='containerName']").val()) {
          errorMessageBox('请题写容器名称');
          return;
        }
        step++;
        if (step >= 3) {
          step = 3;
          $(this).hide();
          that_createContainer.parents('.modal-body').find('.jvc-finish').show();
        } else {
          that_createContainer.parents('.modal-body').find('.jvc-finish').hide();
        }
        if (step >= 1) {
          that_createContainer.parents('.modal-body').find('.jvc-stepP').removeClass('disabledbtn');
        }
        that_createContainer.find('.jvc-step').hide();
        that_createContainer.find('.step-' + step).show();
      })

      that_createContainer.parents('.modal-body').find('.jvc-finish').on('click', function(ec) {
        docker_install(submitContainerData(that_createContainer), id, e);
      })

      that_createContainer.find("input[name='containerName']").keyup(function() {
        if (containerNameS.indexOf($(this).val()) > -1) {
          that_createContainer.find('#jv-warning').text('该名称已被使用');
          that_createContainer.parents('.modal-body').find('.jvc-stepN').addClass('disabledbtn');
        } else {
          that_createContainer.find('#jv-warning').text('');
          that_createContainer.parents('.modal-body').find('.jvc-stepN').removeClass('disabledbtn');
        }
      })

      that_createContainer.find('#jv-myTag').val(info.image);
      $('#jv-subsidiaryDepartment').empty();
      getCrporateCorporat(that_createContainer).then(function() {
        basicContainerData_shop(that_createContainer, res.results);
      });

      changeLanguage(localStorage.getItem('lang'));
      hideLoading();
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  }, false);

}
// 一键安装
function expressinstall(e) {
  var id = "";
  var info = $(e).data('dataInfo');
  id = info.id;
  var data = {
    v: 1,
    act: 'json',
    param: {
      id: id
    }
  }
  let obj = {
    url: '/unas-docker/store/',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(res) {
      var jsoninfo = res.results || {};

      var initConfData = setConfData(jsoninfo, info);
      docker_install(initConfData, id, e, jsoninfo.Mounts, jsoninfo.Config.ExposedPorts);
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  }, 1);

}

//
function closelinkmanualbox() {
  jQuery('#jv-link_manual-box').hide();
}

function closeappdetailbox() {
  jQuery('#jv-appdetail-box').hide();
  currentApp = null;
  currentAppdetail = null;
}

function getImglist() {
  return new Promise(function(resolve, reject) {
    let obj = {
      url: '../api/endpoints/' + globalData.tty + '/docker/images/json?all=0',
      type: "get",
    }

    postData(obj, {
      success: function(result) {
        imageNameS = [];
        for (var i = 0; i < result.length; i++) {
          imageNameS.push(result[i].RepoTags ? result[i].RepoTags.toString() : '');
        }
        resolve(imageNameS);
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    }, false)
  })
}

function searShopData(e) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  if (e) {
    t = e;
  }
  let v = $(t).val().trim();
  $("#jv-d-tbodybox>div:contains(" + v + ")").show();
  $("#jv-d-tbodybox>div:not(:contains(" + v + "))").hide();
}

// 全选
function checkboxAll_shop() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  shopData.checkCount = 0;
  shopData.deleteName = [];
  if (t.checked) {
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      if (e.disabled) {
        return;
      }
      e.checked = true;
      shopData.deleteName.push($(e).data('dataInfo').Id)
    })
  } else {
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      e.checked = false;
      shopData.deleteName = [];
    })
  }
  shopData.checkCount = shopData.deleteName.length;

}

// 单选
function checkboxSelect_shop() {
  let event = window.event || arguments.callee.caller.arguments[0];
  event.stopPropagation();
  let len = $('#jv-d-tbodybox').find('.jvc-checkbox').length;
  shopData.checkCount = 0;
  shopData.deleteName = [];
  $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
    if (e.checked) {
      shopData.checkCount++;
      shopData.deleteName.push($(e).data('dataInfo').id);
    }
  })
  if (shopData.checkCount == len) {
    $('#jv-checkboxAll').prop("checked", true);
  } else {
    $('#jv-checkboxAll').prop("checked", false);
  }

}


//默认容器常规设置数据
function basicContainerData_shop(that, result, get_port = true) {
  // 设置手动网络端口
  let config = result.Config || {};
  var len = Object.keys(config.ExposedPorts || {}).length;
  if (len && get_port) {
    docker_random_ports(len).then(function(ports_t) {
      var p_index = 0;
      for (let variable in config.ExposedPorts) {
        if (config.ExposedPorts.hasOwnProperty(variable)) {
          let key = variable.split('/');
          let sdwldkHost = wfTemplateAppend(that.find('#jv-sdwldkHost'), 'jvt-sdwldk', 'jvt-sdwldk' + key[0] + p_index);
          sdwldkHost.find("input[name='host']").val(ports_t[p_index]);
          sdwldkHost.find("input[name='contalner']").val(key[0]);

          sdwldkHost.find('.selectControlTcpUdp option').each(function(i, e) {
            if ($(e).val() == key[1]) {
              $(e).attr('selected', 'selected');
            }
          })
        }
        p_index++;
      }
    });
  }

  //初始化命令和日志记录数据
  basicContainerCommandLoging_shop(that, result);
  getVolume().then(function(res) {
    initMounts(that, result);
  });
  setTimeout(function() {
    initNetwork(that, result)
  }, 300);
  initEnv(that, result);
  initLabels(that, result);
  initRestartPolicy(that, result);
  initRuntimeResources(that, result);
  initCapabilitiesBtn(that, result);

}

//初始化命令和日志记录数据
function basicContainerCommandLoging_shop(that, result) {

  let cmds = '',
    entrypoints = '';
  if (result.Config.Cmd) {
    if ((typeof result.Config.Cmd == 'object') && result.Config.Cmd.constructor == Array) {
      cmd_parts = [];
      result.Config.Cmd.forEach(element => {
        if (element.search(' ') != -1) {
          cmd_parts.push('"' + element + '"');
        } else {
          cmd_parts.push(element);
        }
      });
      cmds = cmd_parts.join(' ');
    }
    if ((typeof result.Config.Cmd == 'string') && result.Config.Cmd.constructor == String) {
      cmds = result.Config.Cmd;
    }
  }

  if (result.Config.Entrypoint) {
    if ((typeof result.Config.Entrypoint == 'object') && result.Config.Entrypoint.constructor == Array) {
      entrypoint_parts = [];
      result.Config.Entrypoint.forEach(element => {
        if (element.search(' ') != -1) {
          entrypoint_parts.push('"' + element + '"');
        } else {
          entrypoint_parts.push(element);
        }
      });
      entrypoints = entrypoint_parts.join(' ');
    }
    if ((typeof result.Config.Entrypoint == 'string') && result.Config.Entrypoint.constructor == String) {
      entrypoints = result.Config.Entrypoint;
    }
  }

  that.find("input[name='cmd']").val(cmds);
  that.find("input[name='entrypoint']").val(entrypoints);
  that.find("input[name='workingDir']").val(result.Config.WorkingDir);
  that.find("input[name='user']").val(result.Config.User);

}
//初始化网络端口
function docker_random_ports(count) {
  return new Promise(function(resolve, reject) {
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_random_ports",
      "params": {
        count: count
      }
    }

    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }

    postData(obj, {
      success: function(result) {
        var info = result.results || {};
        var ports = info.ports || [];
        resolve(ports);
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    }, false)
  })
}

function installimage_list() {
  var jsonS = [];
  var cklen = jQuery('#jv-d-tbodybox input:checked').length;
  ckdom = $('#jv-d-tbodybox').find('input:checked');

  if (cklen) {
    showLoading();
    setcont();
  }
}

function setcont() {
  confInfo = jQuery(ckdom[0]).data('dataInfo');

  getContainerJson(confInfo.id).then(function(jsoninfo) {

    var initConfData = setConfData(jsoninfo, confInfo);
    docker_install(initConfData, confInfo.id, jQuery(ckdom[0]).closest('div.app-item'), jsoninfo.Mounts, jsoninfo.Config.ExposedPorts).then(function(res) {
      ckdom.splice(0, 1);
      if (ckdom.length) {
        setcont();
      } else {
        hideLoading();
        $('#jv-checkboxAll').prop("checked", false);
      }
    });

  })

}



(function() {

  showLoading();
  getImglist().then(function(imageS) {
    getUnasapp();
  });
  getContainerName();

})();
